---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "decort_cb_extnet Resource - terraform-provider-decort"
subcategory: ""
description: |-
  
---

# decort_cb_extnet (Resource)





<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `gid` (Number) Grid (platform) ID
- `ipcidr` (String) IP network CIDR
- `name` (String) External network name
- `vlan_id` (Number) VLAN ID

### Optional

- `check_ips` (List of String) IPs to check network availability
- `default_qos` (Block List, Max: 1) (see [below for nested schema](#nestedblock--default_qos))
- `desc` (String) Optional description
- `dns` (List of String) List of DNS addresses
- `enable` (Boolean) Disable/Enable extnet
- `end_ip` (String) End of IP range to be explicitly included
- `excluded_ips` (Set of String) IPs to exclude in current extnet pool
- `excluded_ips_range` (Block Set) Range of IPs to exclude in current extnet pool (see [below for nested schema](#nestedblock--excluded_ips_range))
- `gateway` (String) External network gateway IP address
- `migrate` (Number)
- `ntp` (List of String) List of NTP addresses
- `ovs_bridge` (String) OpenvSwith bridge name for ExtNet connection
- `pre_reservations_num` (Number) Number of pre created reservations
- `reserved_ip` (Block Set) (see [below for nested schema](#nestedblock--reserved_ip))
- `restart` (Boolean) restart extnet vnf device
- `set_default` (Boolean) Set current extnet as default (can not be undone)
- `shared_with` (Set of Number)
- `start_ip` (String) Start of IP range to be explicitly included
- `timeouts` (Block, Optional) (see [below for nested schema](#nestedblock--timeouts))
- `virtual` (Boolean) If true - platform DHCP server will not be created
- `vnfdev_ip` (String) IP to create VNFDev with

### Read-Only

- `ckey` (String)
- `default` (Boolean)
- `excluded` (List of Object) (see [below for nested schema](#nestedatt--excluded))
- `extnet_id` (Number)
- `free_ips` (Number)
- `guid` (Number)
- `id` (String) The ID of this resource.
- `meta` (List of String) meta
- `milestones` (Number)
- `network` (String)
- `network_id` (Number)
- `prefix` (Number)
- `pri_vnfdev_id` (Number)
- `reservations` (List of Object) (see [below for nested schema](#nestedatt--reservations))
- `routes` (List of Object) (see [below for nested schema](#nestedatt--routes))
- `status` (String)
- `vnfs` (List of Object) (see [below for nested schema](#nestedatt--vnfs))

<a id="nestedblock--default_qos"></a>
### Nested Schema for `default_qos`

Optional:

- `e_rate` (Number)
- `in_burst` (Number)
- `in_rate` (Number)

Read-Only:

- `guid` (String)


<a id="nestedblock--excluded_ips_range"></a>
### Nested Schema for `excluded_ips_range`

Required:

- `ip_end` (String)
- `ip_start` (String)


<a id="nestedblock--reserved_ip"></a>
### Nested Schema for `reserved_ip`

Required:

- `account_id` (Number)

Optional:

- `ip_count` (Number)
- `ips` (Set of String)


<a id="nestedblock--timeouts"></a>
### Nested Schema for `timeouts`

Optional:

- `create` (String)
- `default` (String)
- `delete` (String)
- `read` (String)
- `update` (String)


<a id="nestedatt--excluded"></a>
### Nested Schema for `excluded`

Read-Only:

- `client_type` (String)
- `domain_name` (String)
- `hostname` (String)
- `ip` (String)
- `mac` (String)
- `type` (String)
- `vm_id` (Number)


<a id="nestedatt--reservations"></a>
### Nested Schema for `reservations`

Read-Only:

- `account_id` (Number)
- `client_type` (String)
- `desc` (String)
- `domain_name` (String)
- `hostname` (String)
- `ip` (String)
- `mac` (String)
- `type` (String)
- `vm_id` (Number)


<a id="nestedatt--routes"></a>
### Nested Schema for `routes`

Read-Only:

- `compute_ids` (List of Number)
- `destination` (String)
- `gateway` (String)
- `guid` (String)
- `netmask` (String)
- `route_id` (Number)


<a id="nestedatt--vnfs"></a>
### Nested Schema for `vnfs`

Read-Only:

- `dhcp` (Number)
