---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "decort_cb_rg Resource - terraform-provider-decort"
subcategory: ""
description: |-
  
---

# decort_cb_rg (Resource)





<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `account_id` (Number) Unique ID of the account, which this resource group belongs to.
- `gid` (Number) Unique ID of the grid, where this resource group is deployed.
- `rg_name` (String) Name of this resource group. Names are case sensitive and unique within the context of a account.

### Optional

- `access` (Block Set) (see [below for nested schema](#nestedblock--access))
- `compute_features` (Set of String)
- `cpu_allocation_parameter` (String) set cpu allocation parameter
- `cpu_allocation_ratio` (Number) set cpu allocation ratio
- `def_net` (Block Set, Max: 1) (see [below for nested schema](#nestedblock--def_net))
- `def_net_type` (String) Type of the network, which this resource group will use as default for its computes - PRIVATE or PUBLIC or NONE.
- `description` (String) User-defined text description of this resource group.
- `enable` (Boolean) enable/disable rg
- `ext_ip` (String) IP address on the external netowrk to request when def_net_type=PRIVATE and ext_net_id is not 0
- `ext_net_id` (Number) ID of the external network for default ViNS. Pass 0 if def_net_type=PUBLIC or no external connection required for the defult ViNS when def_net_type=PRIVATE
- `force` (Boolean) flag to force deleting resource group
- `ipcidr` (String) Address of the netowrk inside the private network segment (aka ViNS) if def_net_type=PRIVATE
- `owner` (String) username - owner of this RG. Leave blank to set current user as owner
- `permanently` (Boolean) flag to permanently delete resource group
- `resource_limits` (Block List, Max: 1) (see [below for nested schema](#nestedblock--resource_limits))
- `restore` (Boolean) restore deleted rg
- `timeouts` (Block, Optional) (see [below for nested schema](#nestedblock--timeouts))
- `uniq_pools` (List of String)

### Read-Only

- `account_name` (String) Name of the account, which this resource group belongs to.
- `acl` (List of Object) (see [below for nested schema](#nestedatt--acl))
- `created_by` (String)
- `created_time` (Number)
- `def_net_id` (Number) ID of the default network for this resource group (if any).
- `deleted_by` (String)
- `deleted_time` (Number)
- `guid` (Number)
- `id` (String) The ID of this resource.
- `lock_status` (String)
- `milestones` (Number)
- `resource_types` (List of String)
- `rg_id` (Number)
- `secret` (String)
- `status` (String) Current status of this resource group.
- `updated_by` (String)
- `updated_time` (Number)
- `vins` (List of Number) List of VINs deployed in this resource group.
- `vms` (List of Number) List of VM ids in this resource group.

<a id="nestedblock--access"></a>
### Nested Schema for `access`

Required:

- `right` (String) Access rights to set, one of 'R', 'RCX' or 'ARCXDU'
- `user` (String) User or group name to grant access


<a id="nestedblock--def_net"></a>
### Nested Schema for `def_net`

Required:

- `net_type` (String) Network type to set. Must be on of 'PRIVATE' or 'PUBLIC'.

Optional:

- `net_id` (Number) Network segment ID. If netType is PUBLIC and netId is 0 then default external network segment will be selected. If netType is PRIVATE and netId=0, the first ViNS defined for this RG will be selected. Otherwise, netId identifies either existing external network segment or ViNS.


<a id="nestedblock--resource_limits"></a>
### Nested Schema for `resource_limits`

Optional:

- `cu_c` (Number) MaxCPUCapacity
- `cu_dm` (Number) MaxVDiskCapacity
- `cu_i` (Number) MaxNumPublicIP
- `cu_m` (Number) MaxMemoryCapacity
- `cu_np` (Number) MaxNetworkPeerTransfer

Read-Only:

- `cu_d` (Number)
- `gpu_units` (Number)


<a id="nestedblock--timeouts"></a>
### Nested Schema for `timeouts`

Optional:

- `create` (String)
- `default` (String)
- `delete` (String)
- `read` (String)
- `update` (String)


<a id="nestedatt--acl"></a>
### Nested Schema for `acl`

Read-Only:

- `explicit` (Boolean)
- `guid` (String)
- `right` (String)
- `status` (String)
- `type` (String)
- `user_group_id` (String)
