---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "decort_cb_vins Resource - terraform-provider-decort"
subcategory: ""
description: |-
  
---

# decort_cb_vins (Resource)





<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `name` (String) name

### Optional

- `account_id` (Number)
- `default_qos` (Block List) default qoa (see [below for nested schema](#nestedblock--default_qos))
- `description` (String) Optional user-defined text description of this ViNS.
- `dns` (Set of String)
- `enable` (Boolean) enable for enable/disable requests
- `ext_ip` (String)
- `ext_net_id` (Number)
- `force` (Boolean) force for delete request
- `gid` (Number)
- `ip` (Block List) (see [below for nested schema](#nestedblock--ip))
- `ipcidr` (String)
- `nat_rule` (Block List) (see [below for nested schema](#nestedblock--nat_rule))
- `permanently` (Boolean) permanently for delete request
- `pre_reservations_num` (Number)
- `rg_id` (Number)
- `timeouts` (Block, Optional) (see [below for nested schema](#nestedblock--timeouts))
- `vins_id` (Number) vins id
- `vnfdev_redeploy` (Boolean)
- `vnfdev_reset` (Boolean)
- `vnfdev_restart` (Boolean)
- `vnfdev_start` (Boolean) true to start vnfdev, false to stop vnfdev

### Read-Only

- `account_name` (String) account name
- `created_by` (String) created by
- `created_time` (Number) created time
- `default_gw` (String) default gw
- `deleted_by` (String) deleted by
- `deleted_time` (Number) deleted time
- `guid` (Number) guid
- `id` (String) The ID of this resource.
- `lock_status` (String) lock status
- `manager_id` (Number) manager id
- `manager_type` (String) manager type
- `milestones` (Number) milestones
- `netmask` (Number) net mask
- `network` (String) network
- `redundant` (Boolean) redundant
- `rg_name` (String) resource group name
- `routes` (Block List) (see [below for nested schema](#nestedblock--routes))
- `sec_vnf_dev_id` (Number)
- `status` (String) status
- `updated_by` (String) updated by
- `updated_time` (Number) updated time
- `user_managed` (Boolean) user managed
- `vnf_dev` (List of Object) vnf dev (see [below for nested schema](#nestedatt--vnf_dev))
- `vnfs` (List of Object) vnfs (see [below for nested schema](#nestedatt--vnfs))
- `vxlan_id` (Number) vxlan id

<a id="nestedblock--default_qos"></a>
### Nested Schema for `default_qos`

Optional:

- `e_rate` (Number)
- `in_burst` (Number)
- `in_rate` (Number)

Read-Only:

- `guid` (String)


<a id="nestedblock--ip"></a>
### Nested Schema for `ip`

Required:

- `type` (String)

Optional:

- `compute_id` (Number)
- `ip_addr` (String)
- `mac` (String)


<a id="nestedblock--nat_rule"></a>
### Nested Schema for `nat_rule`

Required:

- `ext_port_start` (Number)
- `int_ip` (String)

Optional:

- `ext_port_end` (Number)
- `int_port` (Number)
- `proto` (String)

Read-Only:

- `rule_id` (Number)


<a id="nestedblock--timeouts"></a>
### Nested Schema for `timeouts`

Optional:

- `create` (String)
- `default` (String)
- `delete` (String)
- `read` (String)
- `update` (String)


<a id="nestedblock--routes"></a>
### Nested Schema for `routes`

Read-Only:

- `compute_ids` (List of Number)
- `destination` (String)
- `gateway` (String)
- `guid` (String)
- `netmask` (String)
- `route_id` (Number)


<a id="nestedatt--vnf_dev"></a>
### Nested Schema for `vnf_dev`

Read-Only:

- `account_id` (Number)
- `capabilities` (List of String)
- `ckey` (String)
- `config` (List of Object) (see [below for nested schema](#nestedobjatt--vnf_dev--config))
- `config_saved` (Boolean)
- `custom_precfg` (Boolean)
- `description` (String)
- `gid` (Number)
- `guid` (Number)
- `id` (Number)
- `interfaces` (List of Object) (see [below for nested schema](#nestedobjatt--vnf_dev--interfaces))
- `lock_status` (String)
- `meta` (List of String)
- `milestones` (Number)
- `name` (String)
- `status` (String)
- `tech_status` (String)
- `type` (String)
- `vins` (List of Number)
- `vnc_password` (String)

<a id="nestedobjatt--vnf_dev--config"></a>
### Nested Schema for `vnf_dev.config`

Read-Only:

- `mgmt` (List of Object) (see [below for nested schema](#nestedobjatt--vnf_dev--config--mgmt))
- `resources` (List of Object) (see [below for nested schema](#nestedobjatt--vnf_dev--config--resources))

<a id="nestedobjatt--vnf_dev--config--mgmt"></a>
### Nested Schema for `vnf_dev.config.mgmt`

Read-Only:

- `ip_addr` (String)
- `password` (String)
- `ssh_key` (String)
- `user` (String)


<a id="nestedobjatt--vnf_dev--config--resources"></a>
### Nested Schema for `vnf_dev.config.resources`

Read-Only:

- `cpu` (Number)
- `ram` (Number)
- `stack_id` (Number)
- `uuid` (String)



<a id="nestedobjatt--vnf_dev--interfaces"></a>
### Nested Schema for `vnf_dev.interfaces`

Read-Only:

- `bus_number` (Number)
- `conn_id` (Number)
- `conn_type` (String)
- `def_gw` (String)
- `enabled` (Boolean)
- `flipgroup_id` (Number)
- `guid` (String)
- `ip_address` (String)
- `libvirt_settings` (List of Object) (see [below for nested schema](#nestedobjatt--vnf_dev--interfaces--libvirt_settings))
- `listen_ssh` (Boolean)
- `mac` (String)
- `mtu` (Number)
- `name` (String)
- `net_id` (Number)
- `net_mask` (Number)
- `net_type` (String)
- `node_id` (Number)
- `pci_slot` (Number)
- `qos` (List of Object) (see [below for nested schema](#nestedobjatt--vnf_dev--interfaces--qos))
- `target` (String)
- `type` (String)
- `vnfs` (List of Number)

<a id="nestedobjatt--vnf_dev--interfaces--libvirt_settings"></a>
### Nested Schema for `vnf_dev.interfaces.libvirt_settings`

Read-Only:

- `event_idx` (String)
- `guid` (String)
- `ioeventfd` (String)
- `queues` (Number)
- `rx_queue_size` (Number)
- `tx_queue_size` (Number)
- `txmode` (String)


<a id="nestedobjatt--vnf_dev--interfaces--qos"></a>
### Nested Schema for `vnf_dev.interfaces.qos`

Read-Only:

- `e_rate` (Number)
- `guid` (String)
- `in_burst` (Number)
- `in_rate` (Number)




<a id="nestedatt--vnfs"></a>
### Nested Schema for `vnfs`

Read-Only:

- `dhcp` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--dhcp))
- `gw` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--gw))
- `nat` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--nat))

<a id="nestedobjatt--vnfs--dhcp"></a>
### Nested Schema for `vnfs.dhcp`

Read-Only:

- `account_id` (Number)
- `ckey` (String)
- `config` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--dhcp--config))
- `created_time` (Number)
- `devices` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--dhcp--devices))
- `gid` (Number)
- `guid` (Number)
- `id` (Number)
- `lock_status` (String)
- `meta` (List of String)
- `milestones` (Number)
- `owner_id` (Number)
- `owner_type` (String)
- `pure_virtual` (Boolean)
- `routes` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--dhcp--routes))
- `status` (String)
- `tech_status` (String)
- `type` (String)

<a id="nestedobjatt--vnfs--dhcp--config"></a>
### Nested Schema for `vnfs.dhcp.config`

Read-Only:

- `default_gw` (String)
- `dns` (List of String)
- `ip_end` (String)
- `ip_start` (String)
- `lease` (Number)
- `net_mask` (Number)
- `network` (String)
- `reservations` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--dhcp--config--reservations))

<a id="nestedobjatt--vnfs--dhcp--config--reservations"></a>
### Nested Schema for `vnfs.dhcp.config.reservations`

Read-Only:

- `account_id` (Number)
- `ip` (String)
- `mac` (String)
- `type` (String)
- `vm_id` (Number)



<a id="nestedobjatt--vnfs--dhcp--devices"></a>
### Nested Schema for `vnfs.dhcp.devices`

Read-Only:

- `primary` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--dhcp--devices--primary))

<a id="nestedobjatt--vnfs--dhcp--devices--primary"></a>
### Nested Schema for `vnfs.dhcp.devices.primary`

Read-Only:

- `dev_id` (Number)
- `iface01` (String)
- `iface02` (String)



<a id="nestedobjatt--vnfs--dhcp--routes"></a>
### Nested Schema for `vnfs.dhcp.routes`

Read-Only:

- `compute_ids` (List of Number)
- `destination` (String)
- `gateway` (String)
- `guid` (String)
- `netmask` (String)
- `route_id` (Number)



<a id="nestedobjatt--vnfs--gw"></a>
### Nested Schema for `vnfs.gw`

Read-Only:

- `account_id` (Number)
- `ckey` (String)
- `config` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--gw--config))
- `created_time` (Number)
- `devices` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--gw--devices))
- `gid` (Number)
- `guid` (Number)
- `id` (Number)
- `lock_status` (String)
- `meta` (List of String)
- `milestones` (Number)
- `owner_id` (Number)
- `owner_type` (String)
- `pure_virtual` (Boolean)
- `routes` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--gw--routes))
- `status` (String)
- `tech_status` (String)
- `type` (String)

<a id="nestedobjatt--vnfs--gw--config"></a>
### Nested Schema for `vnfs.gw.config`

Read-Only:

- `default_gw` (String)
- `ext_net_id` (Number)
- `ext_net_ip` (String)
- `ext_netmask` (Number)
- `qos` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--gw--config--qos))

<a id="nestedobjatt--vnfs--gw--config--qos"></a>
### Nested Schema for `vnfs.gw.config.qos`

Read-Only:

- `e_rate` (Number)
- `guid` (String)
- `in_burst` (Number)
- `in_rate` (Number)



<a id="nestedobjatt--vnfs--gw--devices"></a>
### Nested Schema for `vnfs.gw.devices`

Read-Only:

- `primary` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--gw--devices--primary))

<a id="nestedobjatt--vnfs--gw--devices--primary"></a>
### Nested Schema for `vnfs.gw.devices.primary`

Read-Only:

- `dev_id` (Number)
- `iface01` (String)
- `iface02` (String)



<a id="nestedobjatt--vnfs--gw--routes"></a>
### Nested Schema for `vnfs.gw.routes`

Read-Only:

- `compute_ids` (List of Number)
- `destination` (String)
- `gateway` (String)
- `guid` (String)
- `netmask` (String)
- `route_id` (Number)



<a id="nestedobjatt--vnfs--nat"></a>
### Nested Schema for `vnfs.nat`

Read-Only:

- `account_id` (Number)
- `ckey` (String)
- `config` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--nat--config))
- `created_time` (Number)
- `devices` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--nat--devices))
- `gid` (Number)
- `guid` (Number)
- `id` (Number)
- `lock_status` (String)
- `meta` (List of String)
- `milestones` (Number)
- `owner_id` (Number)
- `owner_type` (String)
- `pure_virtual` (Boolean)
- `routes` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--nat--routes))
- `status` (String)
- `tech_status` (String)
- `type` (String)

<a id="nestedobjatt--vnfs--nat--config"></a>
### Nested Schema for `vnfs.nat.config`

Read-Only:

- `net_mask` (Number)
- `network` (String)
- `rules` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--nat--config--rules))

<a id="nestedobjatt--vnfs--nat--config--rules"></a>
### Nested Schema for `vnfs.nat.config.rules`

Read-Only:

- `local_ip` (String)
- `local_port` (Number)
- `protocol` (String)
- `public_port_end` (Number)
- `public_port_start` (Number)
- `rule_id` (Number)
- `vm_id` (Number)
- `vm_name` (String)



<a id="nestedobjatt--vnfs--nat--devices"></a>
### Nested Schema for `vnfs.nat.devices`

Read-Only:

- `primary` (List of Object) (see [below for nested schema](#nestedobjatt--vnfs--nat--devices--primary))

<a id="nestedobjatt--vnfs--nat--devices--primary"></a>
### Nested Schema for `vnfs.nat.devices.primary`

Read-Only:

- `dev_id` (Number)
- `iface01` (String)
- `iface02` (String)



<a id="nestedobjatt--vnfs--nat--routes"></a>
### Nested Schema for `vnfs.nat.routes`

Read-Only:

- `compute_ids` (List of Number)
- `destination` (String)
- `gateway` (String)
- `guid` (String)
- `netmask` (String)
- `route_id` (Number)
