---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "decort_disk Resource - terraform-provider-decort"
subcategory: ""
description: |-
  
---

# decort_disk (Resource)





<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `account_id` (Number) The unique ID of the subscriber-owner of the disk
- `disk_name` (String) Name of disk
- `size_max` (Number) Size in GB

### Optional

- `desc` (String) Description of disk
- `detach` (Boolean) Detaching the disk from compute
- `iotune` (Block List, Max: 1) (see [below for nested schema](#nestedblock--iotune))
- `permanently` (Boolean) Whether to completely delete the disk, works only with non attached disks
- `pool` (String) Pool for disk location
- `sep_id` (Number) Storage endpoint provider ID to create disk
- `shareable` (Boolean)
- `timeouts` (Block, Optional) (see [below for nested schema](#nestedblock--timeouts))

### Read-Only

- `account_name` (String) The name of the subscriber '(account') to whom this disk belongs
- `acl` (String)
- `computes` (List of Object) (see [below for nested schema](#nestedatt--computes))
- `created_by` (String)
- `created_time` (Number) Created time
- `deleted_by` (String)
- `deleted_time` (Number) Deleted time
- `destruction_time` (Number) Time of final deletion
- `devicename` (String) Name of the device
- `disk_id` (Number) Disk ID. Duplicates the value of the ID parameter
- `gid` (Number) ID of the grid (platform)
- `id` (String) The ID of this resource.
- `image_id` (Number) Image ID
- `images` (List of String) IDs of images using the disk
- `machine_id` (Number)
- `machine_name` (String)
- `order` (Number) Disk order
- `params` (String) Disk params
- `parent_id` (Number) ID of the parent disk
- `pci_slot` (Number) ID of the pci slot to which the disk is connected
- `present_to` (Map of Number)
- `purge_time` (Number) Time of the last deletion attempt
- `replication` (List of Object) Replication status (see [below for nested schema](#nestedatt--replication))
- `res_id` (String) Resource ID
- `res_name` (String) Name of the resource
- `role` (String) Disk role
- `sep_type` (String) Type SEP. Defines the type of storage system and contains one of the values set in the cloud platform
- `size_used` (Number) Number of used space, in GB
- `snapshots` (List of Object) (see [below for nested schema](#nestedatt--snapshots))
- `status` (String) Disk status
- `tech_status` (String) Technical status of the disk
- `type` (String) The type of disk in terms of its role in compute: 'B=Boot, D=Data, T=Temp'
- `updated_by` (String)
- `updated_time` (Number)
- `vmid` (Number) Virtual Machine ID (Deprecated)

<a id="nestedblock--iotune"></a>
### Nested Schema for `iotune`

Optional:

- `read_bytes_sec` (Number) Number of bytes to read per second
- `read_bytes_sec_max` (Number) Maximum number of bytes to read
- `read_iops_sec` (Number) Number of io read operations per second
- `read_iops_sec_max` (Number) Maximum number of io read operations
- `size_iops_sec` (Number) Size of io operations
- `total_bytes_sec` (Number) Total size bytes per second
- `total_bytes_sec_max` (Number) Maximum total size of bytes per second
- `total_iops_sec` (Number) Total number of io operations per second
- `total_iops_sec_max` (Number) Maximum total number of io operations per second
- `write_bytes_sec` (Number) Number of bytes to write per second
- `write_bytes_sec_max` (Number) Maximum number of bytes to write per second
- `write_iops_sec` (Number) Number of write operations per second
- `write_iops_sec_max` (Number) Maximum number of write operations per second


<a id="nestedblock--timeouts"></a>
### Nested Schema for `timeouts`

Optional:

- `create` (String)
- `default` (String)
- `delete` (String)
- `read` (String)
- `update` (String)


<a id="nestedatt--computes"></a>
### Nested Schema for `computes`

Read-Only:

- `compute_id` (String)
- `compute_name` (String)


<a id="nestedatt--replication"></a>
### Nested Schema for `replication`

Read-Only:

- `disk_id` (Number)
- `pool_id` (String)
- `role` (String)
- `self_volume_id` (String)
- `storage_id` (String)
- `volume_id` (String)


<a id="nestedatt--snapshots"></a>
### Nested Schema for `snapshots`

Read-Only:

- `guid` (String)
- `label` (String)
- `res_id` (String)
- `snap_set_guid` (String)
- `snap_set_time` (Number)
- `timestamp` (Number)
