---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "decort_resgroup Resource - terraform-provider-decort"
subcategory: ""
description: |-
  
---

# decort_resgroup (Resource)





<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `account_id` (Number) Unique ID of the account, which this resource group belongs to.
- `gid` (Number) Unique ID of the grid, where this resource group is deployed.
- `name` (String) Name of this resource group. Names are case sensitive and unique within the context of a account.

### Optional

- `access` (Block Set) (see [below for nested schema](#nestedblock--access))
- `def_net` (Block Set, Max: 1) (see [below for nested schema](#nestedblock--def_net))
- `def_net_type` (String) Type of the network, which this resource group will use as default for its computes - PRIVATE or PUBLIC or NONE.
- `description` (String) User-defined text description of this resource group.
- `enable` (Boolean) flag for enable/disable RG
- `ext_ip` (String) IP address on the external netowrk to request when def_net_type=PRIVATE and ext_net_id is not 0
- `ext_net_id` (Number) ID of the external network for default ViNS. Pass 0 if def_net_type=PUBLIC or no external connection required for the defult ViNS when def_net_type=PRIVATE
- `force` (Boolean) Set to True if you want force delete non-empty RG
- `ipcidr` (String) Address of the netowrk inside the private network segment (aka ViNS) if def_net_type=PRIVATE
- `owner` (String)
- `permanently` (Boolean) Set to True if you want force delete non-empty RG
- `quota` (Block List, Max: 1) Quota settings for this resource group. (see [below for nested schema](#nestedblock--quota))
- `restore` (Boolean)
- `timeouts` (Block, Optional) (see [below for nested schema](#nestedblock--timeouts))
- `uniq_pools` (List of String)

### Read-Only

- `account_name` (String) Name of the account, which this resource group belongs to.
- `acl` (List of Object) (see [below for nested schema](#nestedatt--acl))
- `compute_features` (List of String)
- `cpu_allocation_parameter` (String)
- `cpu_allocation_ratio` (Number)
- `def_net_id` (Number) ID of the default network for this resource group (if any).
- `deleted_by` (String)
- `deleted_time` (Number)
- `dirty` (Boolean)
- `guid` (Number)
- `id` (String) The ID of this resource.
- `lock_status` (String)
- `milestones` (Number)
- `res_types` (List of String)
- `rg_id` (Number)
- `secret` (String)
- `status` (String) Current status of this resource group.
- `updated_by` (String)
- `updated_time` (Number)
- `vins` (List of Number) List of VINs deployed in this resource group.
- `vms` (List of Number) List of computes deployed in this resource group.

<a id="nestedblock--access"></a>
### Nested Schema for `access`

Required:

- `right` (String) Access rights to set, one of 'R', 'RCX' or 'ARCXDU'
- `user` (String) User or group name to grant access


<a id="nestedblock--def_net"></a>
### Nested Schema for `def_net`

Required:

- `net_type` (String) Network type to set. Must be on of 'PRIVATE' or 'PUBLIC'.

Optional:

- `net_id` (Number) Network segment ID. If netType is PUBLIC and netId is 0 then default external network segment will be selected. If netType is PRIVATE and netId=0, the first ViNS defined for this RG will be selected. Otherwise, netId identifies either existing external network segment or ViNS.


<a id="nestedblock--quota"></a>
### Nested Schema for `quota`

Optional:

- `cpu` (Number) Limit on the total number of CPUs in this resource group.
- `disk` (Number) Limit on the total volume of virtual storage resources in this resource group, specified in GB.
- `ext_ips` (Number) Limit on the total number of external IP addresses this resource group can use.
- `ext_traffic` (Number) Limit on the total ingress network traffic for this resource group, specified in GB.
- `ram` (Number) Limit on the total amount of RAM in this resource group, specified in MB.

Read-Only:

- `cu_d` (Number) Limit on the total volume of storage resources in this resource group, specified in GB.
- `gpu_units` (Number) Limit on the total number of virtual GPUs this resource group can use.


<a id="nestedblock--timeouts"></a>
### Nested Schema for `timeouts`

Optional:

- `create` (String)
- `default` (String)
- `delete` (String)
- `read` (String)
- `update` (String)


<a id="nestedatt--acl"></a>
### Nested Schema for `acl`

Read-Only:

- `explicit` (Boolean)
- `guid` (String)
- `right` (String)
- `status` (String)
- `type` (String)
- `user_group_id` (String)
