/*
Copyright (c) 2019-2022 Digital Energy Cloud Solutions LLC. All Rights Reserved.
Authors:
Petr Krutov, <petr.krutov@digitalenergy.online>
Stanislav Solovev, <spsolovev@digitalenergy.online>
Kasim Baybikov, <kmbaybikov@basistech.ru>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package constants

// LIMIT_MAX_VINS_PER_RESGROUP set maximum number of VINs instances per Resource Group
const LIMIT_MAX_VINS_PER_RESGROUP = 4

// MAX_SSHKEYS_PER_COMPUTE sets maximum number of user:ssh_key pairs to authorize when creating new compute
const MAX_SSHKEYS_PER_COMPUTE = 12

// MAX_EXTRA_DISKS_PER_COMPUTE sets maximum number of extra disks that can be added when creating new compute
const MAX_EXTRA_DISKS_PER_COMPUTE = 12

// MAX_NETWORKS_PER_COMPUTE sets maximum number of vNICs per compute
const MAX_NETWORKS_PER_COMPUTE = 8

// MAX_CPUS_PER_COMPUTE sets maximum number of vCPUs per compute
const MAX_CPUS_PER_COMPUTE = 128

// MIN_RAM_PER_COMPUTE sets minimum amount of RAM per compute in MB
const MIN_RAM_PER_COMPUTE = 128

// RAM_DIVISIBILITY sets divisibility of RAM value
const RAM_DIVISIBILITY = 128
