/*
Пример использования
Получение информации об уже существующем диске.
*/

#Раскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_disk" "acl" {
  #id владельца диска
  #обязательный параметр
  #тип - целое число
  #используется при создании
  account_id = 88366

  #имя диска
  #обязательный параметр
  #тип - строка
  #используется при создании и обновлении
  disk_name = "super-disk-re"

  #размер диска, в ГБ
  #обязательный параметр
  #тип - целое число
  #используется при создании и обновлении
  size_max = 20

  #флаг для отключения диска от ВМ при удалении
  #опциональный параметр
  #тип - булев
  #используется при удалении
  #detach = false

  #флаг для удаления диска, без возможности восстановления
  #опциональный параметр
  #тип - булев
  #используется при удалении
  #permanently = false

  #флаг, отвечающий за доступность диска другим ресурсам
  #опциональный параметр
  #тип - строка
  #используется при создании и обновлении
  #shareable = false

}

output "test" {
  value = decort_disk.acl
}
