/*
Пример использования
Работа с ресурсом flipgroup (группа с плавающим ip-адресом)
Ресурс позволяет:
1. Создавать flipgroup
2. Редактировать flipgroup
3. Удалять flipgroup
*/

#Раскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator  = "decs3o"
  oauth2_url     = "https://sso-alpha.dev.decs.online"
  controller_url = "https://alpha.dev.decs.online"
  app_id         = ""
  app_secret     = ""
}

resource "decort_cb_flipgroup" "fg" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  #используется при создании
  account_id = 999

  #наименование Flipgroup
  #обязательный параметр
  #тип - строка
  #используется при создании и обновлении
  name = "flipgroup_name"

  #тип сети
  #обязательный параметр
  #возможные значенния - "EXTNET", "VINS"
  #тип - строка
  #используется при создании
  net_type = "EXTNET"

  #id сети
  #обязательный параметр
  #тип - целое число
  #используется при создании
  net_id = 13

  #тип клиентов
  #обязательный параметр
  #тип - строка
  #в данный момент поддерживается только тип 'compute'
  #используется при создании
  client_type = "compute"

  #ip-адрес
  #опциональный параметр
  #тип - строка
  #используется при создании
  #ip = "127.0.0.1"

  #cписок клиентов, прикрепленных к флипгруппе
  #опциональный параметр
  #тип - массив целых чисел
  #используется при создании и обновлении
  #client_ids = [11269]

  #описание флипгруппы
  #опциональный параметр
  #тип - строка
  #используется при создании и обновлении
  #desc = "CHANGED"
}

output "fg_out" {
  value = decort_cb_flipgroup.fg
}
