/*
Пример использования
Ресурса cdrom image
Ресурс позволяет:
1. Создавать образ
2. Редактировать образ
3. Удалять образ
*/

#Раскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_cdrom_image" "my_image" {
  #имя образа
  #обязательный параметр
  #тип - строка
  #используется при создании и обновлении
  name = "test_image_rename"

  #адрес образа
  #обязательный параметр
  #тип - строка
  #используется при создании
  url = "https://colba.decs.online/index.php/s/G3H7AREngzeKGw2/download"

  #драйвера
  #опциональный параметр
  #тип - массив строк
  #возможные варианты - ["KVM_X86", "SVA_KVM_X86"], ["KVM_X86"], ["SVA_KVM_X86"]
  #используется при создании
  #drivers = ["KVM_X86", "SVA_KVM_X86"]

  #поддержка hot resize
  #опциональный параметр
  #тип - булев
  #используется при создании и обновлении
  #hot_resize = true

  #id аккаунта владельца образа
  #опциональный параметр
  #тип - целое число
  #используется при создании и обновлении
  #account_id = 57252

  #имя пользователя и пароль для загрузки бинарных данных
  #опциональные параметры
  #тип - строка
  #используется при создании и обновлении
  #username_dl = "Valera1"
  #password_dl = "1231"

  #sep id
  #опциональный параметр
  #тип - целое число
  #используется при создании
  #sep_id = 1206

  #пул для создания образа
  #опциональный тип
  #тип - строка
  #используется при создании
  #pool_name = "vmstor"

  #архитектура системы образа
  #опциональный параметр
  #тип - строка
  #доступные значения: "X86_64"
  #используется при создании
  #architecture = "X86_64"

  #доступность образа
  #опциональный параметр
  #тип - булев
  #используется при обновлении
  #enabled = true

  #настройка доступа образа аккаунтам
  #опциональный параметр
  #тип - массив целых чисел
  #пустой массив - удаление всех доступов, если они были
  #используется при обновлении
  #shared_with = [28096, 57121]

  #установка computeci
  #опциональный параметр
  #тип - целое число
  #чтобы сбросить, необходимо передать 0
  #используется при обновлении
  #computeci_id = 1

  #доступные стаки
  #опциональный параметр
  #тип - массив целых чисел
  #для удаления всех доступных стаков, необходимо передать пустой массив
  #используется при обновлении
  #enabled_stacks = [9]

  #является ли образ загрузочным 
  #опциональный параметр
  #тип - булев
  #используется при обновлении
  #bootable = true
}

output "test" {
  value = decort_cb_cdrom_image.my_image
}
