/*
Пример использования
Ресурса load balancer frontend bind (привязка фронтенда балансировщика нагрузки)
Ресурс позволяет:
1. Создавать привязку
2. Редактировать привязку
3. Удалять привязку
*/

#Раскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_lb_frontend_bind" "lbfb" {
  #id балансировщика нагрузки
  #обязательный параметр
  #тип - целое число
  #используется при создании
  lb_id = 668

  #имя фронтенда для создания привязки
  #обязательный параметр
  #тип - строка
  #используется при создании
  frontend_name = "testFrontend"

  #наименование привязки
  #обязательный параметр
  #тип - строка
  #используется при создании
  name = "testBinding"

  #адрес привязки фронтенда
  #обязательный параметр
  #тип - строка
  #используется при создании и обновлении
  address = "111.111.111.111"

  #порт для привязки фронтенда
  #обязательный параметр
  #тип - целое число
  #используется при создании и обновлении
  port = 1111
  
}

output "test" {
  value = decort_cb_lb_frontend_bind.lbfb
}
