/*
Пример использования
Ресурсов RG
Ресурс позволяет:
1. Создавать RG
2. Редактировать RG
3. Удалять RG
*/

#Раскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_rg" "rg" {
  #имя ресурсной группы
  #обязательный параметр
  #тип - строка
  #используется при создании и обновлении
  rg_name = "testing_rg_1"

  #id аккаунта которому будет принадлежать ресурсная группа
  #обязательный параметр
  #тип - целое число
  #используется при создании
  account_id = 123

  #id сети
  #обязательный параметр
  #тип - целое число
  #используется при создании
  gid = 1234

  #лимиты ресурсов
  #опциональные параметры
  #тип - блок лимитов на ресурсы
  #используется при создании и обновлении
  #resource_limits  {
    #максимальное количество ядер cpu
    #опциональный параметр
    #тип - целое число
    #cu_c = 12

    #максимальный размер агрегированных виртуальных дисков в ГБ
    #опциональный параметр
    #тип - целое число
    #cu_dm = 12

    #максимальное количество назначенных общедоступных IP-адресов
    #опциональный параметр
    #тип - целое число
    #cu_i = 12

    #максимальный объем памяти в МБ
    #опциональный параметр
    #тип - целое число
    #cu_m = 12

    #максимальный пиринг отправленных/принятых сетевых передач
    #опциональный параметр
    #тип - целое число
    #cu_np = 12
  #}

  #имя владельца ресурсной группы
  #опциональный параметр
  #тип - строка
  #используется при создании
  #owner = "owner name"

  #тип сети по умолчанию для этой ресурсной группы. 
  #виртуальные машины, созданные в этой RG, по умолчанию будут подключены к этой сети. 
  #допустимые значения: PRIVATE, PUBLIC, NONE.
  #опциональный параметр
  #по умолчанию: PRIVATE
  #тип - строка
  #используется при создании
  #def_net_type = "NONE"

  #описание
  #опциональный параметр
  #тип - строка
  #используется при создании и обновлении
  #description = "qwerty"

  #id внешней сети
  #опциональный параметр
  #тип - целое число
  #используется при создании
  #ext_net_id = 123

  #ip внешней сети
  #опциональный параметр
  #тип - строка
  #используется при создании
  #ext_ip = "1.1.1.1"

  #список названий pools
  #опциональный параметр
  #тип - массив строк
  #используется при создании и обновлении
  #uniq_pools = ["sep1_poolName1", "sep2_poolName2"]

  #блок для предоставления прав на ресурсную группу
  #опциональный параметр
  #тип - блок прав пользователя
  #используется при создании и обновлении
  #access  {
    #имя юзера предоставляемому права 
    #обязательный параметр при использовании блока
    #тип - строка
    #user = "kasim_baybikov_1@decs3o"

    #тип прав
    #обязательный параметр
    #тип - строка
    #разрешенные значения: "R", "RCX" or "ARCXDU"
    #right = "RCX"
  #}

  #установить сеть по умолчанию
  #опциональный параметр
  #тип - блок конфигурации сети
  #при добавлении блока, удалять его нельзя
  #используется при создании
  #def_net {
    #тип сети
    #обязательный параметр при использовании блока
    #тип - строка
    #net_type = "PUBLIC"

    #id сети
    #идентификатор сегмента сети. Если net_type — PUBLIC, а net_id — 0, 
    #то будет выбран сегмент внешней сети по умолчанию. Если net_type 
    #имеет значение PRIVATE и net_id=0, будет выбран первый vins, определенный для этой ресурсной группы. 
    #в противном случае net_id идентифицирует либо существующий сегмент внешней сети, либо vins.
    #опциональный параметр
    #тип - целое число
    #net_id = 1234
  #}

  #может ли запуститься ВМ, если ресурсов CPU недостаточно
  #опциональный параметр
  #допустимые значения: strict, loose.
  #тип - строка
  #используется при создании и обновлении
  #cpu_allocation_parameter = "loose"

  #cpu allocation ratio
  #опциональный параметр
  #one pCPU = ratio*vCPU (zero or positive value)
  #тип - целое число
  #используется при создании и обновлении
  #cpu_allocation_ratio = 1

  #флаг доступности ресурсной группы
  #опциональный параметр
  #тип - булев
  #используется при создании и обновлении
  #enable = true

  #флаг для восстановления удаленной ресурсной группы
  #опциональный параметр
  #тип - булев
  #используется при обновлении
  #restore = false

  #флаг для принудительного удаления ресурсной группы
  #опциональный параметр
  #тип - булев
  #перед удалением следует перевести ресурсную группу в статус disabled, выставив enable = false
  #используется при удалении
  #force = true

  #флаг для удаления ресурсной группы, без возможности восстановления
  #опциональный параметр
  #тип - булев
  #используется при удалении
  #permanently = true

  #доступ к дополнительным функциям управления ВМ
  #опциональный параметр
  #возможные значенния - "hugepages", "numa", "cpupin", "vfnic",  "dpdk, "changemac"
  #тип - массив строк
  #внимание - требуется указывать итоговое желаемое состояние для ресурсной группы (рг), так как поле compute_features не будет автоматически
  #наследоваться от аккаунта, в котором создается рг.
  #используется при создании и обновлении
  #compute_features = ["hugepages", "numa", "cpupin", "vfnic"]

}

output "output" {
  value = decort_cb_rg.rg
}
