Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_extnet_list** служит для получения информации об имеющихся доступных внешних сетях.

## Аргументы
_Data source_ функция **decort_extnet_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| by_id | int | :x: | Фильтр по extnet ID |
| name | string | :x: | Фильтр по имени extnet |
| network | string | :x: | Фильтр по сети |
| vlan_id | int | :x: | Фильтр по VLAN ID |
| vnfdev_id | int | :x: | Фильтр по VnfDEV ID |
| status | string | :x: | Фильтр по статусу |
| account_id | int | :x: | ID аккаунта для фильтрации результата поиска |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_extnet_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| net_id | int | ID сети |
| ipcidr | string | Маска сети |
| name | string | Название сети |

## Пример использования
Пример вызова _data source_ функции **decort_extnet_list**:
```terraform
data "decort_extnet_list" "el" {
  #id аккаунта для фильтрации результата
  #необязательный параметр
  #тип - число
  #account_id = 13

  #Фильтр по имени extnet
  #необязательный параметр
  #тип - строка
  #name = "test"

  #кол-во страниц для вывода
  #опицональный параметр 
  #тип - число
  #page = 1

  #размер страницы
  #опицональный параметр 
  #тип - число
  #size = 1
}
# once the above directive completes, extnet list will be accessible 
# as data.decort_extnet_list.el.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_extnet_list** в переменной `data.decort_extnet_list.el` будут сохранены возвращаемые значения.
