Функция доступна в провайдере версии 4.4.1 и выше.

_Data source_ функция **decort_kvmvm_pci_device_list** служит для получения информации о доступных компьюту списка устройств с шиной PCI.

## Аргументы
_Data source_ функция **decort_kvmvm_pci_device_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | id компьюта |
| rg_id | int | :x: | Фильтр по ID ресурсной группы |
| device_id | int | :x: | Фильтр по ID устройства |
| name | string | :x: | Фильтр по имени |
| status | string | :x: | Фильтр по статусу |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_kvmvm_pci_device_list** возвращает в указанную при вызове переменную, в поле _items_ массив строк

## Пример использования
Пример вызова _data source_ функции **decort_kvmvm_pci_device_list**:
```terraform
data "decort_kvmvm_pci_device_list" "pci_device_list" {
  #id виртуальной машины
  #обязательный параметр
  #тип - число
  compute_id = 100
 
  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - число
  #rg_id = 100

  #фильтр по id устройства
  #опциональный параметр
  #тип - число
  #device_id = 100

  #фильтр по имени устройства
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #номер страницы для отображения
  #опциональный параметр
  #тип - число
  #если не задан - выводятся все доступные данные
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - число
  #если не задан - выводятся все доступные данные
  #size = 1
}
# once the above directive completes, pcidevice list will be accessible 
# as data.decort_kvmvm_pci_device_list.pl.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_kvmvm_pci_device_list** в переменной `data.decort_kvmvm_pci_device_list.pci_device_list` будут сохранены возвращаемые значения.
