Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_disk_snapshot_list** служит для получения списка снимков состояния диска.

## Аргументы
_Data source_ функция **decort_cb_disk_snapshot_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| disk_id | int | :heavy_check_mark: | ID диска для получения списка снимком состояния |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_disk_snapshot_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип    | Описание |
| --- |--------| --- |
| label | string | Название снимка |
| guid | string | ID снимка |
| timestamp | int    | Время снимка |
| reference_id | string | ID ссылки |
| res_id | string | Ссылка на снимок |
| snap_set_guid | string | ID набора снимков, в котором лежит снимок состояния |
| snap_set_time | int    | Время набора |

## Пример использования
Пример вызова _data source_ функции **decort_cb_disk_snapshot_list**:
```terraform
data "decort_cb_disk_snapshot_list" "dsl" {
  disk_id = 11111
}
# once the above directive completes, disk snapshot list will be accessible 
# as data.decort_cb_disk_snapshot_list.dsl.items
```

После успешного завершения такого вызова **decort_cb_disk_snapshot_list** в переменной `data.decort_cb_disk_snapshot_list.dsl.items` будут сохранены возвращаемые значения.
