Функция доступна в провайдере версии 4.1.0 и выше.

_Resource_ функция **decort_flipgroup** служит для управления плавающими группами (флипгруппами). Функция позволяет:
- Создать флипгруппу
- Удалить флипгруппу
- Добавить/удалить клиентов

## Аргументы
_Resource_ функция **decort_flipgroup** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | :---: | --- |
| account_id | int | :heavy_check_mark: | ID аккаунта |
| name | string | :heavy_check_mark: | Название флипгруппы |
| net_type | string | :heavy_check_mark: | Тип сети, EXTNET или ViNS |
| net_id | int | :heavy_check_mark: | ID сети |
| client_type | string | :heavy_check_mark: | Тип клиента (в данный момент поддерживается только compute) |
| ip | string | :x: | IP для ассоциации с группой |
| client_ids | []int | :x: | Список ID клиентов группы |
| desc | string | :x: | Описание плавающей группы |

## Возвращаемые значения

| Параметр      | Тип      | Описание                                   |
| ------------  | -------  | ------------------------------------------ |
| account_id    | int      | ID аккаунта                                |
| account_name  | string   | Имя аккаунта                               |
| client_ids    | []int    | Список ID подключенных к группе клиентов   |
| client_names  | []string | Список имен подключенных клиентов          |
| client_type   | string   | Тип клиентов, подключаемых к группе        |
| conn_id       | int      | ID подключения                             |
| conn_type     | string   | Тип подключения                            |
| created_by    | string   | Кем создана группа                         |
| created_time  | int      | Время создания                             |
| default_gw    | string   | Шлюз по умолчанию                          |
| deleted_by    | string   | Кем удалена группа                         |
| deleted_time  | int      | Время удаления                             |
| desc          | string   | Описание группы                            |
| gid           | int      | Grid ID платформы                          |
| guid          | int      | ID флипгруппы на платформе (=flipgroup_id) |
| milestones    | int      | Веха                                       |
| name          | string   | Наименование плавающей группы              |
| net_id        | int      | ID сети                                    |
| net_type      | string   | Тип сети (EXTNET/ViNS)                     |
| network       | string   | Сеть                                       |
| rg_id         | int      | ID ресурсной группы                        |
| rg_name       | string   | Наименование ресурсной группы              |
| status        | string   | Статус плавающей группы                    |
| updated_by    | string   | Кем обновлена группа                       |
| updated_time  | int      | Время обновления                           |

## Пример использования

```terraform
resource "decort_flipgroup" "fg" {
  # ID аккаунта
  # Обязательный параметр
  # int
  account_id = 999

  # Наименование Flipgroup
  # Обязательный параметр
  # string
  name = "flipgroup_name"

  # Тип сети (EXTNET, ViNS)
  # Обязательный параметр
  # string
  net_type = "EXTNET"

  # ID сети
  # Обязательный параметр
  # int
  net_id = 13

  # Тип клиентов (в данный момент поддерживается только тип 'compute')
  # Обязательный параметр
  # string
  client_type = "compute"

  # IP-адрес
  # Опциональный параметр
  # string
  ip = "127.0.0.1"

  # Список клиентов, прикрепленных к флипгруппе
  # Опциональный параметр
  # []int
  client_ids = [11269]

  # Описание флипгруппы
  # Опциональный параметр
  # string
  desc = "CHANGED"
}
```

После успешного завершения такого вызова **decort_flipgroup** в переменной `decort_flipgroup.fg` будут сохранены возвращаемые значения.
