Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_consumed_units** служит для получения информации об используемых аккаунтом ресурсах.  


## Аргументы
_Data source_ функция **decort_account_consumed_units** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_consumed_units** возвращает следующие параметры:
| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| cu_c | float | Кол-во используемых ядер |
| cu_d | float | Размер используемых дисков, ГБ |
| cu_i | float | Кол-во используемых публичных IP-адресов |
| cu_m | float | Размер используемой RAM, МБ |
| cu_dm | float | Использованный размер хранилища виртуального диска |
| cu_np | float | Кол-во траффика, ГБ |
| gpu_units | float | Кол-во графических ядер |


## Пример использования
Пример вызова _data source_ функции **decort_account_consumed_units**:
```terraform
data "decort_account_consumed_units" "acu" {
  #id аккаунта
  #обязательный параметр
  #тип - число
  account_id = 11111
}
# once the above directive completes, consumed units will be accessible 
# as data.decort_account_consumed_units.acu
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_consumed_units** в переменной `data.decort_account_consumed_units.acu` будут сохранены возвращаемые значения.
