Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_list** служит для получения информации о всех доступных аккаунтах.

## Аргументы
_Data source_ функция **decort_account_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| by_id | int | :x: | Фильтр по ID аккаунта |
| name | string | :x: | Фильтр по имени аккаунта |
| acl | string | :x: | Фильтр по ACL |
| status | string | :x: | Фильтр по статусу |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| account_name | string | Название аккаунта |
| acl | []Struct{<br/>explicit bool<br/>guid string<br/>right string<br/>status string<br/>type string<br/>user_group_id string<br/>} | Более подробная информация об аккаунтах<br/>Явно ли указан доступ<br/>guid аккаунта<br/>Права доступа<br/>Статус аккаунта<br/>Тип аккаунта<br/>Идентификатор пользователя-владельца аккаунта<br/>&nbsp;<br/> |
| created_time | int | Время создания аккаунта |
| deleted_time | int | Время удаления аккаунта |
| status | string | Статус аккаунта |
| updated_time | int | Время последнего обновления |

## Пример использования
Пример вызова _data source_ функции **decort_account_list**:
```terraform
data "decort_account_list" "al" {
  #номер страницы для отображения
  #опциональный параметр
  #тип - число
  #если не задан - выводятся все доступные данные
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - число
  #если не задан - выводятся все доступные данные
  #size = 3
}
# once the above directive completes, account list will be accessible 
# as data.decort_account_list.al.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_list** в переменной `data.decort_account_list.al` будут сохранены возвращаемые значения.
