_Data source_ функция **decort_flipgroup** служит для получения информации о плавающей группе (флипгруппы)

## Аргументы

| Аргумент | Тип | Обязательный | Описание |
| -------- | --- | ------------ | -------- |
| flipgroup_id   | int | :heavy_check_mark: | ID флипгруппы |

## Возвращаемые значения

| Параметр     | Тип    | Описание                                   |
|--------------|--------|--------------------------------------------|
| account_id   | int    | ID аккаунта                                |
| account_name | string | Имя аккаунта                               |
| client_ids   | []int  | Список ID подключенных к группе клиентов   |
| client_type  | string | Тип клиентов, подключаемых к группе        |
| conn_id      | int    | ID подключения                             |
| created_by   | string | Кем была создана флипгруппа                |
| created_time | int    | Время создания флипгруппы                  |
| deleted_by   | string | Кем удалена флипгруппа                     |
| deleted_time | int    | Время удаления флипгруппы                  |
| conn_type    | string | Тип подключения                            |
| default_gw   | string | Шлюз по умолчанию                          |
| desc         | string | Описание группы                            |
| gid          | int    | Grid ID платформы                          |
| guid         | int    | ID флипгруппы на платформе (=flipgroup_id) |
| milestones   | int    | Веха                                       |
| name         | string | Наименование плавающей группы              |
| net_id       | int    | ID сети                                    |
| net_type     | string | Тип сети (EXTNET/ViNS)                     |
| network      | string | Информация о сети                          |
| rg_id        | int    | ID ресурсной группы                        |
| rg_name      | string | Имя ресурсной группы                       |
| status       | string | Статус плавающей группы                    |
| updated_by   | string | Кем была обновлена флипгруппа              |
| updated_time | int    | Время последнего обновления флипгруппы     |

## Пример использования

```terraform
data "decort_flipgroup" "fg" {
  # ID плавающей группы
  # Обязательный параметр
  # int
  flipgroup_id = 18
}
```

После успешного завершения такого вызова **decort_flipgroup** в переменной `data.decort_flipgroup.fg` будут сохранены возвращаемые значения.
