Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_lb_list_deleted** служит для получения информации об удаленных балансировщиках нагрузки. 

## Аргументы
_Data source_ функция **decort_cb_lb_list_deleted** принимает следующие аргументы:

| Аргумент       | Тип    | Обязательный | Описание                                      |
|----------------|--------|--------------|-----------------------------------------------|
| by_id          | int    | :x:          | Фильтр по ID балансировщика                   |
| name           | string | :x:          | Фильтр по имени балансировщика                |
| account_id     | int    | :x:          | Фильтр по ID аккаунта                         |
| rg_id          | int    | :x:          | Фильтр по ID рес. группы                      |
| tech_status    | string | :x:          | Фильтр по тех. статусу                        |
| front_ip       | string | :x:          | Фильтр по IP фронтенда                        |
| back_ip        | string | :x:          | Фильтр по IP бэкенда                          |
| page           | int    | :x:          | Номер страниц                                 |
| size           | int    | :x:          | Размер страницы                               |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_lb_list_deleted** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр        | Тип                                                               | Описание                                     |
|-----------------|-------------------------------------------------------------------|----------------------------------------------|
| ha_mode         | bool                                                              | Флаг, показывающий, включен ли режим haproxy |
| acl             | string                                                            | Cписок Acces Control                         |
| backend_haip    | string                                                            | Backend highly available ip                  |
| backends        | []Struct{} [см. ниже](#описание-структуры-backends)               | Список бекендов                              |
| created_by      | string                                                            | Аккаунт, создавший балансировщик             |
| created_time    | int                                                               | Время создания                               |
| deleted_by      | string                                                            | Кем балансировщик был удален                 |
| deleted_time    | int                                                               | Время удаления                               |
| desc            | string                                                            | Описание                                     |
| dp_api_user     | string                                                            | Имя пользователя для работы                  |
| dp_api_password | string                                                            | Пароль пользователя                          |
| extnet_id       | int                                                               | ID внешней сети                              |
| frontend_haip   | string                                                            | Frontend highly available ip                 |
| frontends       | []Struct{} [см. ниже](#описание-структуры-frontends)              | Список фронтендов                            |
| gid             | int                                                               | Grid ID балансировщика                       |
| guid            | int                                                               | ID балансировщика                            |
| lb_id           | int                                                               | ID балансировщика                            |
| milestones      | int                                                               | Вехи                                         |
| name            | string                                                            | Имя балансировщика                           |
| primary_node    | Struct{} [см. описание узлов](#описание-структуры-primary_node)   | Главный узел                                 |
| rg_id           | int                                                               | ID ресурсной группы                          |
| rg_name         | string                                                            | Имя ресурсной группы                         |
| secondary_node  | Struct{} [см. описание узлов](#описание-структуры-secondary_node) | Второй узел                                  |
| status          | string                                                            | Статус                                       |
| tech_status     | string                                                            | Технический статус                           |
| updated_by      | string                                                            | Кем балансировщик был обновлен               |
| updated_time    | string                                                            | Время последнего обновления                  |
| vins_id         | int                                                               | ID виртуальной сети                          |

### Описание структуры backends
| Параметр                | Тип                                                                                                                                                                                                                               | Описание                                        |
|-------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-------------------------------------------------|
| algorithm               | string                                                                                                                                                                                                                            | Алгоритм работы бекенда                         |
| guid                    | string                                                                                                                                                                                                                            | ID ресурса                                      |
| name                    | string                                                                                                                                                                                                                            | Имя бекенда                                     |
| server_default_settings | Struct{} [см. ниже](#описание-структуры-server_default_settings)                                                                                                                                                                  | Описание настроек серверов бекенда по умолчанию |
| servers                 | []Struct{} [см. ниже](#описание-структуры-servers) | Список серверов                                 |

### Описание структуры server_default_settings
| Параметр  | Тип    | Описание                                                                                         |
|-----------|--------|--------------------------------------------------------------------------------------------------|
| downinter | int    | Интервал между проверками на недоступность сервера                                               |
| guid      | string | ID ресурса                                                                                       |
| inter     | int    | Интервал между проверками на доступность сервера                                                 |
| rise      | int    | Кол-во попыток, после которых, сервер будет вновь включен в схему балансирования                 |
| fall      | int    | Кол-во неудачных попыток, после которых, сервер получит статус "unavailable"                     |
| slowstart | int    | Интервал, в мс, в через который сервер получит статус "available"                                |
| maxconn   | int    | Кол-во соединений к северу, при достижении этого кол-ва, сервера выходит из схемы балансирования |
| maxqueue  | int    | Кол-во соедений в очереди к серверу                                                              |
| weight    | int    | Вес сервера для работы алгоритма балансирования по весу                                          |

### Описание структуры servers
| Параметр        | Тип                                                        | Описание             |
|-----------------|------------------------------------------------------------|----------------------|
| address         | string                                                     | Адрес сервера        |
| check           | string                                                     | Включены ли проверки |
| name            | string                                                     | Имя сервера          |
| port            | int                                                        | Порт сервера         |
| guid            | string                                                     | ID ресурса           |
| server_settings | []Struct{} [см. ниже](#описание-структуры-server_settings) | Настройки сервера    |

### Описание структуры server_settings
| Параметр  | Тип    | Описание                                                                                         |
|-----------|--------|--------------------------------------------------------------------------------------------------|
| downinter | int    | Интервал между проверками на недоступность сервера                                               |
| guid      | string | ID ресурса                                                                                       |
| inter     | int    | Интервал между проверками на доступность сервера                                                 |
| rise      | int    | Кол-во попыток, после которых, сервер будет вновь включен в схему балансирования                 |
| fall      | int    | Кол-во неудачных попыток, после которых, сервер получит статус "unavailable"                     |
| slowstart | int    | Интервал, в мс, в через который сервер получит статус "available"                                |
| maxconn   | int    | Кол-во соединений к северу, при достижении этого кол-ва, сервера выходит из схемы балансирования |
| maxqueue  | int    | Кол-во соедений в очереди к серверу                                                              |
| weight    | int    | Вес сервера для работы алгоритма балансирования по весу                                          |

### Описание структуры frontends
| Параметр | Тип                                                                                                                                                                                                                                | Описание                                   |
|----------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|--------------------------------------------|
| backend  | string                                                                                                                                                                                                                             | Имя бекенда, к которому подключен фронтенд |
| guid     | string                                                                                                                                                                                                                             | ID ресурса                                 |
| name     | string                                                                                                                                                                                                                             | Имя фронтенда                              |
| bindings | []Struct{} [см. ниже](#описание-структуры-bindings) | Привязки фронтенда                         |

### Описание структуры bindings
| Параметр | Тип    | Описание                            |
|----------|--------|-------------------------------------|
| address  | string | Адрес, к которому привязан фронтенд |
| name     | string | Имя привязки                        |
| port     | int    | Порт привязки                       |
| guid     | string | ID ресурса                          |

### Описание структуры primary_node
| Параметр    | Тип    | Описание              |
|-------------|--------|-----------------------|
| backend_ip  | string | IP адрес бекенда      |
| compute_id  | int    | ID виртуальной машины |
| frontend_ip | string | IP адрес фронтенда    |
| guid        | string | ID ресурса            |
| mgmt_ip     | string | IP адрес              |
| network_id  | int    | ID сети               |

### Описание структуры secondary_node
| Параметр    | Тип    | Описание              |
|-------------|--------|-----------------------|
| backend_ip  | string | IP адрес бекенда      |
| compute_id  | int    | ID виртуальной машины |
| frontend_ip | string | IP адрес фронтенда    |
| guid        | string | ID ресурса            |
| mgmt_ip     | string | IP адрес              |
| network_id  | int    | ID сети               |

## Пример использования
Пример вызова _data source_ функции **decort_cb_lb_list_deleted**:

```terraform
data "decort_cb_lb_list_deleted" "lbld" {
  #by_id = 100
  #name = "test"
  #account_id = 11111
  #rg_id = 100
  #tech_status = "STOPPED"
  #front_ip = "1.1.1.1."
  #back_ip = "1.1.1.1"
  #page = 1
  #size = 1
}
```

После успешного завершения такого вызова **decort_cb_lb_list_deleted** в переменной `data.decort_cb_lb_list_deleted.lbld` будут сохранены возвращаемые значения.
