Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_audit_list** служит для получения списка событий системы, вызванных действиями пользователя.

## Аргументы
_Data source_ функция **decort_cb_audit_list** принимает следующие аргументы:

| Аргумент     | Тип    | Обязательный | Описание                                                                  |
|--------------|--------|--------------|---------------------------------------------------------------------------|
| timestamp_at | int    | :x:          | Отдает все события, созданные после определенного времени (unix timstamp) |
| timestamp_to | int    | :x:          | Отдает все события, созданные до определенного времени (unix timstamp)    |
| user         | string | :x:          | Пользователь для выборки (Mongo RegExp supported)                         |
| call         | string | :x:          | Фильтр по команде, которая была выполнена                                 |
| status_code  | int    | :x:          | Фильтр по статусу выполнения запроса                                      |
| page         | int    | :x:          | Номер страниц                                                             |
| size         | int    | :x:          | Размер страницы                                                           |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_audit_list** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр     | Тип    | Описание                               |
|--------------|--------|----------------------------------------|
| call         | string | Какая команда была выполнена           |
| guid         | string | ID ресурса                             |
| responsetime | float  | Время выполнения                       |
| status_code  | int    | Статус выполнения                      |
| timestamp    | float  | Точное время исполнения                |
| user         | string | Кем была выполнена команда             |

## Пример использования
Пример вызова _data source_ функции **decort_cb_audit_list**:

```terraform
data "decort_cb_audit_list" "audit_list" {
  #timestamp_at = 123456
  #timestamp_to = 123456
  #user = "username"
  #call = "/restmachine/cloudbroker/audit/list"
  #status_code = 200
  #page = 2
  #size = 3
}
# Once the above directive completes, audit list will be accessible as
# data.decort_cb_audit_list.audit_list.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_audit_list** в переменной `data.decort_cb_audit_list.audit_list.items` будут сохранены возвращаемые значения.
