Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_k8s_list_deleted** служит для получения информации о списке удаленных кластеров Kubernetes (k8s).

## Аргументы

_Data source_ функция **decort_cb_k8s_list_deleted** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по ID кластера |
| name | string | :x: | Фильтр по имени кластера |
| ip_address | string | :x: | Фильтр по IP адресу |
| rg_id | int | :x: | Фильтр по ID рес. группы |
| lb_id | int | :x: | Фильтр по ID балансировщика |
| basic_service_id | int | :x: | Фильтр по ID basic service |
| tech_status | string | :x: | Фильтр по тех. статусу |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_k8s_list_deleted** возвращает в указанную при вызове переменную, в поле items массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип                                                     | Описание                        |
| --- |---------------------------------------------------------|---------------------------------|
| acl | []string                                               | acl                             |
| account_id | int                                                     | ID аккаунта                     |
| account_name | string                                                  | Имя аккаунта                    |
| bservice_id | int                                                     | ID bservice                     |
| k8sci_id | int                                                     | ID образа кластера              |
| created_by | string                                                  | Кем был создан ресурс           |
| created_time | int                                                     | Время создания ресурса          |
| deleted_by | string                                                  | Кем был удален ресурс           |
| deleted_time | int                                                     | Время удаления ресурса          |
| desc | string                                                  | Описание кластера               |
| extnet_id | int                                                     | ID внешней сети                 |
| gid | int                                                     | GRID ID                         |
| guid | int                                                     | ID ресурса                      |
| k8s_id | int | ID кластера |
| name | string                                                  | Имя кластера              |
| kubeconfig | string                                                  | Конфиг                          |
| lb_id | int                                                     | ID балансировщика нагрузки      |
| milestones | int                                                     | Вехи                            |
| network_plugin | string                                                  | Сетевой плагин                  |
| rg_id | int                                                     | ID ресурсной группы             |
| rg_name | string                                                  | Имя ресурсной группы            |
| service_account | Struct{} [см. ниже](#описание-структуры-service_account) | информация о аккаунте кластера  |
| ssh_key | string                                                  | Публичный SSH ключ              |
| status | string                                                  | Статус ресурса                  |
| tech_status | string                                                  | Технический статус ресурса      |
| updated_by | string                                                  | Кем был обновлен ресурс         |
| updated_time | int                                                     | Время последнего обновления ресурса |
| vins_id | int                                                     | ID виртуальной сети             |
| workers_groups | []Struct{} [см. ниже](#описание-структуры-workers_groups) | Структура компьютов воркеров        |

### Описание структуры service_account

| Параметр | Тип    | Описание |
| --- |--------| --- |
| guid | string   | ID ресурса |
| password | string | Пароль аккаунта |
| username | string | Username аккаунта |

### Описание структуры workers_groups

| Параметр | Тип | Описание |
| --- | --- | --- |
| annotations | []string | Аннотации группы workers |
| cpu | int | Кол-во cpu на компьютах workers |
| detailed_info | []Struct{} [см. ниже](#описание-структуры-списка-detailed_info) | Детальная информация masters |
| disk | int | ID диска |
| guid | string | ID ресурса |
| id | int | ID группы workers |
| labels | []string | Лейблы группы workers |
| name | string | Имя ресурса |
| num | int | Кол-во компьютов в группе workers |
| ram | int | Кол-во Ram на компьютах группы workers |
| taints | []string | огранечители группы workers |

### Описание структуры списка detailed_info

| Параметр | Тип | Описание |
| --- | --- | --- |
| external_ip    | string | Внешний ip                                             |
| compute_id | int | ID компьюта в составе группы |
| name | string | Имя компьюта в составе группы |
| status | string | Статус компьюта в составе группы |
| tech_status | string | Статус компьюта в составе группы |
| interfaces | []Struct{} [см. ниже](#описание-структуры-списка-interfaces) | Список интерфейсов группы |

### Описание структуры списка interfaces

| Параметр | Тип | Описание |
| --- | --- | --- |
| def_gw | string | Шлюз по умолчанию |
| ip_address | string | IP интерфейса |

## Пример использования

Пример вызова _data source_ функции **decort_cb_k8s_list_deleted**:

```terraform
data "decort_cb_k8s_list_deleted" "k8s_list_deleted" {
  #by_id = 100
  #name = "test"
  #ip_address = "1.1.1.1"
  #rg_id = 100
  #lb_id = 100
  #bservice_id = 100
  #tech_status = "STOPPED"
  #page = 1
  #size = 1
}
```

После успешного завершения такого вызова **decort_cb_k8s_list_deleted** в переменной `data.decort_cb_k8s_list_deleted.k8s_list_deleted` будут сохранены возвращаемые значения.
