Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_kvmvm_snapshot_usage** служит для получения информации о использовании снапшотов.

Ресурсная группа в облачной платформе DECORT это способ группирования _compute_-ов (например, по функциональному признаку или принадлежности к одному и тому же проекту). Ресурсную группу можно рассматривать как небольшой персональный дата-центр, в котором размещаются один или несколько серверов и виртуальных сетевых сегментов (ViNS).

Экземпляры _compute_ (виртуальные серверы) всегда создаются в принадлежности к какой-либо ресурсной группе. Как следствие, для создания экземпляра _compute_ помимо других параметров требуется указать идентификатор целевой ресурсной группы. Для получения такого идентификатора можно воспользоваться рассматриваемой здесь _data source_ функцией **decort_cb_kvmvm_snapshot_usage**.

## Аргументы
_Data source_ функция **decort_cb_kvmvm_snapshot_usage** принимает следующие аргументы:

| Аргумент | Тип    | Обязательный | Описание |
| --- |--------| --- | --- |
| compute_id | int    | :heavy_check_mark: | Идентификатор компьюта |
| label | string | :x: | Название снапшота |

Пользователь облачной платформы задается на стадии инициализации Terraform провайдера DECORT (см. [подробности](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_kvmvm_snapshot_usage** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| count | int | Количество компьютов, использующих снапшот |
| stored | float | Stored |
| label | string | Название снапшота |
| timestamp | int | Время снапшота |

## Пример использования
Пример вызова _data source_ функции **decort_cb_kvmvm_snapshot_usage**:

```terraform
data "decort_cb_kvmvm_snapshot_usage" "snapshot_usage" {
  compute_id = 1234
  #label = "label1"
}
# Once the above directive completes, snapshot usage will be accessible as
# data.decort_cb_kvmvm_snapshot_usage.snapshot_usage.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.5.3/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_kvmvm_snapshot_usage** в переменной `data.decort_cb_kvmvm_snapshot_usage.snapshot_usage.items` будут сохранены возвращаемые значения.
