Функция доступна в провайдере версии 3.5.0 и выше.

_Data source_ функция **decort_kvmvm_user_list** служит для получения информации о Access Control List компьюта.

## Аргументы

_Data source_ функция **decort_kvmvm_user_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | ID компьюта |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_kvmvm_user_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_acl | []Struct [см. ниже](#описание-структуры-list-acl) | Информация о списке пользователей аккаунтов |
| compute_acl | []Struct [см. ниже](#описание-структуры-list-acl) | Информация о списке пользователей компьютов |
| rg_acl | []Struct [см. ниже](#описание-структуры-list-acl) | Информация о списке пользователей ресурной группы |

### Описание структуры List acl
| Параметр | Тип | Описание |
| --- | --- | --- |
| explicit | bool | Явно ли указан доступ |
| guid | string | guid Ресурса |
| right | string | Права на ресурс |
| status | string | Статус ресурса |
| type | string | Тип ресурса |
| user_group_id | string | ID user group |

## Пример использования
```terraform
data "decort_kvmvm_user_list" "kvmvm_user_list" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  compute_id = 10154
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова _data source_ функции **decort_kvmvm_user_list** в переменной `data.decort_kvmvm_user_list.user_list` будут сохранены возвращаемые значения. 
