Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_kvmvm_pfw_list** служит для получения списка pfw компьюта.

## Аргументы

_Data source_ функция **decort_cb_kvmvm_pfw_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | ID компьюта |
| reason | string | :x: | Причина вызова |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_kvmvm_pfw_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| pfw_id | int | ID pfw |
| local_ip | string | Локальный ip адрес |
| local_port | int | Локальный порт |
| protocol | string | Протокол tcp/udp |
| public_port_end | int | Конец диапазона внешних портов |
| public_port_start | int | Начало диапазона внешних портов |
| vm_id | int | ID компьюта |

## Пример использования
```terraform
data "decort_cb_kvmvm_pfw_list" "pfw_list" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  compute_id = 10154
  
  #причина запроса
  #опциональный параметр
  #тип - строка
  #reason = "test"
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова _data source_ функции **decort_cb_kvmvm_pfw_list** в переменной `data.decort_cb_kvmvm_pfw_list.pfw_list.items` будут сохранены возвращаемые значения. 
