Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_sep_disk_list** служит для получения информации о дисках, которые использует sep. Storage endpoint (sep) - точка доступа к хранилищу данных. Sep бывает четырех типов:

- des
- hitachi
- dorado
- tatlin

Каждый тип отличается возможной конфигурацией.

## Аргументы

_Data source_ функция **decort_cb_sep_disk_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| sep_id | int | :heavy_check_mark: | ID storage endpoint |
| pool_name | string | :x: | Название pool, по которому получить данные.<br/>В случае, если не указан - возвращается информация по всем pool'ам |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_sep_disk_list** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | int | id storage endpoint |
| pool_name | string | Название pool, по которому осуществлялся поиск |
| items | []int | Список id дисков |

## Пример использования

Пример вызова _data source_ функции **decort_cb_sep_disk_list**:

```terraform
data "decort_cb_sep_disk_list" "sdl" {
  #id sep
  #обязательный параметр
  #тип - целое число
  sep_id = 1111

  #sep pool name
  #опциональный параметр
  #тип - строка
  #pool_name = "sep_pool"
}
# once the above directive completes, disk list will be accessible
# as data.decort_cb_sep_disk_list.sdl.items
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_sep_disk_list** в переменной `data.decort_cb_sep_disk_list.sdl` будут сохранены возвращаемые значения.
