Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_sep** служит для получения информации о переданном storage endpoint. Storage endpoint (sep) - точка доступа к хранилищу данных. Sep бывает четырех типов:

- des
- hitachi
- dorado
- tatlin

Каждый тип отличается возможной конфигурацией.

## Аргументы

_Data source_ функция **decort_cb_sep** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| sep_id | int | :heavy_check_mark: | ID storage endpoint |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_sep** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | int | id storage endpoint |
| ckey | string | CKey |
| meta | []string | Мета информация о sep |
| config | json string | Конфигурация sep |
| consumed_by | []int | Список node id, использующих sep |
| desc | string | Описание sep |
| gid | int | Grid id, к которому привязан sep |
| guid | int | Внутренний id sep |
| milestones | int | Вехи |
| name | string | Наименование sep |
| obj_status | string | Статус sep |
| provided_by | []int | Список provider id, использующих sep |
| shared_with | []int | Список id учетных записей, у которых есть доступ к sep |
| tech_status | string | Технический статус sep |
| type | string | Тип sep |

## Пример использования

Пример вызова _data source_ функции **decort_cb_sep**:

```terraform
data "decort_cb_sep" "s" {
  #id sep
  #обязательный параметр
  #тип - целое число
  sep_id = 1111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_sep** в переменной `data.decort_cb_sep.s` будут сохранены возвращаемые значения.

Чтобы получить доступ к конфигурации и сохранить ее в файл .json, необходимо:

1. определить в .tf - файле дополнительный output с любым именем, в который запишется информация о конфигурации sep и обернуть ее в вызов функции jsondecode для декодирования информации.

```terraform
output "sep_config" {
    value = jsondecode(data.decort_cb_sep.s.config)
}
```

2. Применить изменения в терраформе.

```bash
terraform apply
```

3. Сохранить данные из output в .json - файл.

```bash
terraform output -json sep_config >> config.json
```

В общем случае это будет выглядеть как указано ниже.

```bash
terraform output -json <output-name> >> <file-name>.json
```
