Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_grid_list_consumption** служит для получения информации и потребленных и зарезервированных ресурсах во всех grid. Grid это пространства, на которых возможно размещение виртуальных машин.

## Аргументы

_Data source_ функция **decort_cb_grid_list_consumption** не имеет входных параметров.

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_grid_list_consumption** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| consumed | []Struct{} [см. ниже](#описание-структуры-consumed) | Потребленные ресурсы |
| reserved | []Struct{} [см. ниже](#описание-структуры-reserved) | Зарезервированные ресурсы |
| id | int | grid id |

### Описание структуры consumed
| Параметр | Тип | Описание |
| --- | --- | --- |
| cpu | int | Количество процессоров |
| disk_size | float | Размер диска |
| disk_size_max | int | Максимальный размер диска |
| ext_ips | int | Лимит на суммарное потребление внешних IP адресов |
| ext_traffic | int | Лимит на суммарный трафик |
| gpu | int | Количество GPU |
| ram | int | Количество RAM |
| seps | []Struct{} [см. ниже](#описание-структуры-seps) | Коннекторы к системе хранения данных seps |

### Описание структуры reserved
| Параметр | Тип | Описание |
| --- | --- | --- |
| cpu | int | Количество процессоров |
| disk_size | float | Размер диска |
| disk_size_max | int | Максимальный размер диска |
| ext_ips | int | Лимит на суммарное потребление внешних IP адресов |
| ext_traffic | int | Лимит на суммарный трафик |
| gpu | int | Количество GPU |
| ram | int | Количество RAM |
| seps | []Struct{} [см. ниже](#описание-структуры-seps) | Коннекторы к системе хранения данных seps |

### Описание структуры seps
| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | string | id sep |
| data_name | string | Имя пула информации внутри SEP'а |
| disk_size | float | Размер диска |
| disk_size_max | float | Максимальный размер диска |

## Пример использования

Пример вызова _data source_ функции **decort_cb_grid_list_consumption**:

```terraform
data "decort_cb_grid_list_consumption" "glс" {
  #нет входящих параметров
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_grid_list_consumption** в переменной `data.decort_cb_grid_list_consumption.glc` будут сохранены возвращаемые значения.
