Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_extnet_computes_list** служит для получения информации о вычислительных ресурсах, использующих внешнюю сеть.

## Аргументы
_Data source_ функция **decort_extnet_computes_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | Идентификатор аккаунта, которому принадлежат вычислительные ресурсы |
| rg_id | int | :x: | ID ресурсной группы для фильтрации результата поиска |
| compute_id | int | :x: | ID виртуальной машины для фильтрации результата поиска |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_extnet_computes_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта - владельца вычислительных ресурсов |
| account_name | string | Имя аккаунта - владельца вычислительных ресурсов |
| extnets | []Struct [см. ниже](#описание-структуры-extnets) | Список сетей |
| rg_id | int | Идентификатор ресурсной группы |
| rg_name | string | Название ресурсной группы |
| id | int | Идентификатор вычислительных ресурсов |
| name | string | Название вычислительных ресурсов |

### Описание структуры extnets
| Параметр | Тип | Описание |
| --- | --- | --- |
| net_id | int | ID сети |
| ipaddr | string | IP адрес |
| ipcidr | string | Маска сети |
| name | string | Название сети |

## Пример использования
Пример вызова _data source_ функции **decort_extnet_computes_list**:
```terraform
data "decort_extnet_computes_list" "ecl" {
  #идентификатор аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 1111

  #фильтр по id ресурсной группы
  #опциональный параметр 
  #тип - целое число
  #rg_id = 11111

  #фильтр по id виртуальной машины
  #опциональный параметр 
  #тип - целое число
  #compute_id = 11111

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #кол-во страниц для вывода
  #опциональный параметр
  #тип - целое число
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #size = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_extnet_computes_list** в переменной `data.decort_extnet_computes_list.ecl` будут сохранены возвращаемые значения.
