_Data source_ функция **decort_rg_list_pfw** служит для получения информации о списке pfw ресурсной группы.

Ресурсная группа в облачной платформе DECORT это способ группирования _compute_-ов (например, по функциональному признаку или принадлежности к одному и тому же проекту). Ресурсную группу можно рассматривать как небольшой персональный дата-центр, в котором размещаются один или несколько серверов и виртуальных сетевых сегментов (ViNS).

Экземпляры _compute_ (виртуальные серверы) всегда создаются в принадлежности к какой-либо ресурсной группе. Как следствие, для создания экземпляра _compute_ помимо других параметров требуется указать идентификатор целевой ресурсной группы. Для получения такого идентификатора можно воспользоваться рассматриваемой здесь _data source_ функцией **decort_rg_list_pfw**.

## Аргументы
_Data source_ функция **decort_rg_list_pfw** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| rg_id | :heavy_check_mark: | int | Идентификатор ресурсной группы |

Пользователь облачной платформы, от лица которого происходит обращение к данной функции, должен иметь доступ к указанному `account` и ресурсной группе. В противном случае возникнет ошибка доступа.

Пользователь облачной платформы задается на стадии инициализации Terraform провайдера DECORT (см. [подробности](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_rg_list_pfw** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:
| Параметр | Тип | Описание |
| --- | --- | --- |
| public_port_end | int | Конец диапазона внешних портов |
| public_port_start | int | Начало диапазона внешних портов |
| vm_id | int | ID компьюта |
| vm_ip | string | Локальный ip адрес vm |
| vm_name | string | Имя vm | 
| vm_port | int | Порт vm |
| vins_id | int | Идентификатор vins |
| vins_name | string | Имя vins |

## Пример использования
Пример вызова _data source_ функции **decort_rg_list_pfw**:

```terraform
data "decort_rg_list_pfw" "list_pfw" {
  #id ресурсной группы
  #обязательный параметр
  #тип - целое число
  rg_id = 123
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.2/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.2/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_rg_list_pfw** в переменной `data.decort_rg_list_pfw.list_pfw` будут сохранены возвращаемые значения. В частности, для получения идентификатора ресурсной группы следует использовать конструкцию `data.decort_rg_list_pfw.list_pfw.id`
