Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_sep_consumption** служит для получения информации о загрузке переданного storage endpoint. Storage endpoint (sep) - точка доступа к хранилищу данных. Sep бывает четырех типов:

- des
- hitachi
- dorado
- tatlin

Каждый тип отличается возможной конфигурацией.  
Загрузка sep состоит из загрузки его pool. Поэтому, информация предоставляется как по каждому pool'у, так и общая.

## Аргументы

_Data source_ функция **decort_cb_sep_consumption** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| sep_id | int | :heavy_check_mark: | ID storage endpoint |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_sep_consumption** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | int | id storage endpoint |
| by_pool | []Struct{<br/>name string<br/>disk_count int<br/>disk_usage int<br/>snapshot_count int<br/>snapshot_usage int<br/>usage int<br/>usage_limit int<br/>} | Список нагрузки по каждому pool<br/>Наименование pool<br/>Количество дисков<br/>Количество используемых дисков<br/>Количество snapshots<br/>Количество используемых snapshots<br/>Используемое место<br/>Максимально доступное пространство<br/>&nbsp; |
| total | Struct{<br/>capacity_limit int<br/>disk_count int<br/>disk_usage int<br/>snapshot_count int<br/>snapshot_usage int<br/>usage int<br/>usage_limit int<br/>} | Общая загрузка по каждому pool<br/>Ограничение емкости<br/>Количество дисков<br/>Количество используемых дисков<br/>Количество snapshots<br/>Количество используемых snapshots<br/>Используемое место<br/>Максимально доступное пространство<br/>&nbsp; |
| type | string | Тип sep |

## Пример использования

Пример вызова _data source_ функции **decort_cb_sep_consumption**:

```terraform
data "decort_cb_sep_consumption" "sc" {
  #id sep
  #обязательный параметр
  #тип - целое число
  sep_id = 1111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_sep_consumption** в переменной `data.decort_cb_sep_consumption.sc` будут сохранены возвращаемые значения.
