Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_computes_list** служит для получения информации о вычислительных мощностях (computes), которые использует аакаунт.

## Аргументы
_Data source_ функция **decort_account_computes_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |
| compute_id | int | :x: | Фильтр по ID компьюта |
| name | string | :x: | Фильтр по имени компьюта |
| rg_name | string | :x: | Фильтр по имени рес. группы |
| rg_id | int | :x: | Фильтр по ID рес. группы |
| tech_status | string | :x: | Фильтр по тех. статусу |
| ip_address | string | :x: | Фильтр по IP адресу |
| extnet_name | string | :x: | Фильтр по имени extnet |
| extnet_id | int | :x: | Фильтр по ID extnet |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_computes_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| account_name | string | Имя аккаунта |
| compute_id | int | ID экземпляра computes |
| compute_name | string | Название экземпляра computes |
| cpus | int | Кол-во используемых ядер |
| created_by | string | Информация о создателе вычислительной мощности |
| created_time | int | Время создания вычислительной мощности |
| deleted_by | string | Информация о том, кто удалил вычислительную мощность |
| deleted_time | int | Время удаления вычислительной мощности |
| ram | int | Кол-во используемой RAM |
| registered | bool | Флаг, показатель того, зарегистрирована ли мощность как используемая или нет |
| rg_id | int | Идентификатор ресурсной группы |
| rg_name | string | Название ресурсной группы |
| status | string | Статус вычислительной мощности |
| tech_status | string | Технический статус вычислительной мощности |
| total_disks_size | int | Общее место, используемое дисками вычислительной мощности |
| updated_by | string | Кем вычислительная мощность была обновлена в последний раз |
| updated_time | int | Время последнего обновления |
| user_managed | bool | Флаг, показывает управление пользователем вычислительной мощностью |
| vins_connected | int | Общее число подключенных и используемых vins |

## Пример использования
Пример вызова _data source_ функции **decort_account_computes_list**:
```terraform
data "decort_account_computes_list" "acl" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 1111

  #фильтр по id compute
  #опциональный параметр
  #тип - целое число
  #compute_id = 100

  #фильтр по имени compute
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по имени ресурсной группы
  #опциональный параметр
  #тип - строка
  #rg_name = "test"

  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - целое число
  #rg_id = 100

  #фильтр по техническому статусу
  #опциональный параметр
  #тип - строка
  #tech_status = "STARTED"

  #фильтр по ip address
  #опциональный параметр
  #тип - строка
  #ip_address = "1.1.1.1.1"

  #фильтр по имени внешней сети
  #опциональный параметр
  #тип - строка
  #extnet_name = "test"

  #фильтр по id внешней сети
  #опциональный параметр
  #тип - целое число
  #extnet_id = 100

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_computes_list** в переменной `data.decort_account_computes_list.acl` будут сохранены возвращаемые значения.
