Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_account_templates_list** служит для получения информации об имеющихся шаблонах аккаунта.

## Аргументы
_Data source_ функция **decort_account_templates_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :heavy_check_mark: | ID аккаунта |
| include_deleted | bool | :x: | Включить в рез-тат удаленные шаблоны |
| image_id | int | :x: | Фильтр по id образа |
| name | string | :x: | Фильтр по имени шаблона |
| type | string | :x: | Фильтр по типу шаблона |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_account_templates_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| unc_path | string | Системный путь до шаблона |
| account_id | int | ID аккаунта - владельца шаблона |
| desc | string | Описание шаблона |
| template_id | int | Идентификатор шаблона |
| template_name | string | Название шаблона |
| public | bool | Флаг, является ли шаблон общедоступным |
| size | int | Размер шаблона |
| status | string | Статус шаблона |
| type | string | Тип шаблона |
| username | string | Пользователь - владелец шаблона |

## Пример использования
Пример вызова _data source_ функции **decort_account_templates_list**:
```terraform
data "decort_account_templates_list" "atl" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 11111

  #фильтр "включая удаленные шаблоны"
  #опциональный параметр
  #тип - булев
  #include_deleted = true

  #фильтр по id образа
  #опциональный параметр
  #тип - целое число
  #image_id = 1111

  #фильтр по имени
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по типу
  #опциональный параметр
  #тип - строка
  #type = "linux"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 3
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_account_templates_list** в переменной `data.decort_account_templates_list.atl` будут сохранены возвращаемые значения.
