Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_vins_ip_list** служит для получения резервированных ip-адресов dhcp на внутренней сети vins.

## Аргументы
_Data source_ функция **decort_cb_vins_ip_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| vins_id | int | :heavy_check_mark: | ID vins |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_vins_ip_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| client_type | string | Тип клиента |
| domain_name | string | Имя домена |
| host_name | string | Имя хоста |
| ip | string | IP адрес |
| mac | string | MAC адрес |
| type | string | Тип сети |
| vm_id | int | ID виртуальной машины |

## Пример использования
Пример вызова _data source_ функции **decort_cb_vins_ip_list**:
```terraform
data "decort_cb_vins_ip_list" "ipl" {
  #id желаемого vins
  #обязательный параметр
  #тип - целое число
  vins_id = 10101
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_vins_ip_list** в переменной `data.decort_cb_vins_ip_list.ipl` будут сохранены возвращаемые значения.
