Функция доступна в провайдере версии 4.6.0 и выше.

_Data source_ функция **decort_cb_user_get_audit** служит для получения аудитов пользователя.

## Аргументы

_Data source_ функция **decort_cb_user_get_audit** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| username | string | :x: | Имя пользователя (если не указано, выводит данные по текущему пользователю) |
| call | string | :x: | Фильтр по вызову API |
| status_code | int | :x: | Фильтр статус коду ответа |
| timestamp_at | int | :x: | Фильтр по временной метке, после которой были сделаны запросы |
| timestamp_to | int | :x: | Фильтр по временной метке, до которой были сделаны запросы |
| page | int | :x: | Номер страницы для отображения |
| size | int | :x: | Размер страницы |

## Возвращаемые значения

В случае успешного выполнения *data source* функция **decort_cb_user_get_audit** возвращает в указанную при вызове переменную, в поле *items*, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| call | string | Адрес вызова API |
| response_time | float | Время ответа |
| status_code | int | Код ответа |
| time | float | Время получения запроса |

## Пример использования

Пример вызова *data source* функции **decort_cb_user_get_audit**:

```terraform
data "decort_cb_user_get_audit" "audits" {
  #имя пользователя (если не указано, выводит данные по текущему пользователю)
  #опциональный параметр
  #тип - строка
  #username = "test_user"

  #фильтр по вызову api
  #опциональный параметр
  #тип - строка
  #call = "restapi/user/get"

  #фильтр по статус коду ответа
  #опциональный параметр
  #тип - целое число
  #status_code = 200

  #фильтр по временной метке, после которой были сделаны запросы
  #опциональный параметр
  #тип - целое число
  #timestamp_at = 123456

  #фильтр по временной метке, до которой были сделаны запросы
  #опциональный параметр
  #тип - целое число
  #timestamp_to = 123456

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #size = 3
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.4/04.02-Инициализация-Terraform-провайдера-DECORT.md). 

После успешного завершения такого вызова _data source_ функции **decort_cb_user_get_audit** в переменной `data.decort_cb_user_get_audit.audits` будут сохранены возвращаемые значения.
