Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_vins_static_route_list** служит для получения списка статических маршрутов для внутренней сети vins.

## Аргументы
_Data source_ функция **decort_cb_vins_static_route_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| vins_id | int | :heavy_check_mark: | ID vins |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_vins_static_route_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_ids | []int | Список ID compute, которым предоствавлен доступ |
| route_id | int | ID статического маршрута |
| guid | int | ID ресурса |
| destination | string | IP целевой сети |
| netmask | int | Маска сети |
| gateway | string | IP шлюза |

## Пример использования
Пример вызова _data source_ функции **decort_cb_vins_static_route_list**:
```terraform
data "decort_cb_vins_static_route_list" "srl" {
  #id vins в котором добавлены routes
  #обязательный параметр
  #тип - целое число
  vins_id = 10101
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.6.4/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_vins_static_route_list** в переменной `data.decort_cb_vins_static_route_list.srl` будут сохранены возвращаемые значения.
