Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_vins_list** служит для получения списка удаленных виртуальных сетей (Vins).

## Аргументы

_Data source_ функция **decort_vins_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по ID |
| name | string | :x: | Фильтр по имени |
| account_id | int | :x: | Фильтр по ID аккаунта |
| rg_id | int | :x: | Фильтр по ID рес. группы |
| ext_ip | string | :x: | Фильтр по внешнему IP адресу |
| vnf_dev_id | int | :x: | Фильтр по VNF Device id |
| includedeleted | bool | :x: | Включить в результат удаленные балансировщики |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_vins_list** возвращает в указанную при вызове переменную, в поле items массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта - владельца виртуальной сети |
| account_name | string | Имя аккаунта - владельца виртуальной |
| created_by | string | Информация о создателе виртуальной сети |
| created_time | int | Время создания виртуальной сети |
| deleted_by | string | Информация о том, кто удалил виртуальную сеть |
| deleted_time | int | Время удаления виртуальной сети |
| external_ip | string | Внешний ip - адрес |
| extnet_id | int | Идентификатор внешней сети |
| free_ips | int | Кол-во свободных IP адресов |
| vins_id | int | Идентификатор виртуальной сети |
| vins_name | string | Название виртуальной сети |
| network | string | Сеть |
| rg_id | int | Идентификатор ресурсной группы |
| rg_name | string | Название ресурсной группы |
| status | string | Статус виртуальной сети |
| updated_by | string | Кем виртуальная сеть была обновлена в последний раз |
| updated_time | int | Время последнего обновления |
| vxlan_id | int | Идентификатор vxlan |

## Пример использования

Пример вызова _data source_ функции **decort_vins_list**:

```terraform
data "decort_vins_list" "vl" {
  #фильтр по id vins
  #опциональный параметр
  #тип - целое число
  #by_id = 100
 
  #фильтр по имени vins
  #опциональный параметр
  #тип - строка
  #name = "test"

  #id аккаунта для получения списка балансировщиков нагрузки
  #опциональный параметр 
  #тип - целое число
  #account_id = 11111

  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - целое число
  #rg_id = 100

  #фильтр по IP внешней сети
  #опциональный параметр
  #тип - строка
  #ext_ip = "test"

  #фильтр по VNF Device id
  #опциональный параметр
  #тип - целое число
  #vnf_dev_id = 14

  #включение удаленных vins в результат
  #опциональный параметр
  #тип - булев
  #если не задан - выводятся все неудаленные данные
  #include_deleted = true

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 1

}
```

После успешного завершения такого вызова **decort_vins_list** в переменной `data.decort_vins_list.vins_list` будут сохранены возвращаемые значения.

