Функция доступна в провайдере версии 4.4.1 и выше.

_Data source_ функция **decort_kvmvm_pci_device_list** служит для получения информации о доступных компьюту списка устройств с шиной PCI.

## Аргументы
_Data source_ функция **decort_kvmvm_pci_device_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| compute_id | int | :heavy_check_mark: | id компьюта |
| rg_id | int | :x: | Фильтр по ID ресурсной группы |
| device_id | int | :x: | Фильтр по ID устройства |
| name | string | :x: | Фильтр по имени |
| status | string | :x: | Фильтр по статусу |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_kvmvm_pci_device_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_id | int | id вычислительной площадки |
| description | string | Описание |
| guid | int | Внутренний id |
| hwpath | string | HW Путь |
| device_id | int | id устройства |
| name | string | Наименование устройства |
| rg_id | int | id ресурсной группы (resource group) |
| stack_id | int | id стэка |
| status | string | Статус устройства |
| system_name | string | Системное имя устройства |

## Пример использования
Пример вызова _data source_ функции **decort_kvmvm_pci_device_list**:
```terraform
data "decort_kvmvm_pci_device_list" "pci_device_list" {
  #id виртуальной машины
  #обязательный параметр
  #тип - целое число
  compute_id = 100
 
  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - целое число
  #rg_id = 100

  #фильтр по id устройства
  #опциональный параметр
  #тип - целое число
  #device_id = 100

  #фильтр по имени устройства
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_kvmvm_pci_device_list** в переменной `data.decort_kvmvm_pci_device_list.pci_device_list` будут сохранены возвращаемые значения.
