Функция доступна в провайдере версии 4.6.0 и выше.

_Resource_ функция **decort_cb_vfpool** служит для управления устройствами vfpool.

## Аргументы
_Resource_ функция **decort_cb_vfpool** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| name | string | :heavy_check_mark: | Наименование |
| description | string | :x: | Описание |
| account_access | []int | :x: | Список имеющих доступ к vfpool учетных записей |
| rg_access | []int | :x: | Список имеющих доступ к vfpool ресурсных групп |
| config | Struct{} [см. ниже](#описание-структуры-config)) | :x: | Конфигурационные данные |
| enable | bool | :x: | Флаг доступности vfpool |

### Описание структуры config

| Параметр | Тип | Описание |
| --- | --- | --- |
| node_id | int | ID узла |
| nic_name | string | Название сетевого адаптера |
| vf_ids | []int | Список ID виртуальных функций |

## Возвращаемые значения

В случае успешного выполнения _resource_ функция **decort_cb_vfpool** возвращает в указанную при вызове переменную следующие значения:

| Параметр | Тип | Описание |
| --- | --- | --- |
| name | string | Наименование |
| description | string | Описание |
| account_access | []int | Список имеющих доступ к vfpool учетных записей |
| rg_access | []int | Список имеющих доступ к vfpool ресурсных групп |
| created_time | int | Дата создания |
| gid | int | Grid ID |
| guid | int | Guid пользователя vfpool |
| vfpool_id | int | ID устройства vfpool |
| status | string | Состояние |
| updated_time | int | Дата изменения |
| vfs | []Struct [см. ниже](#описание-структуры-vfs) | Список параметров |

### Описание структуры vfs
| Параметр | Тип | Описание |
| --- | --- | --- |
| node_id | int | ID узла |
| vf_list | []Struct [см. ниже](#описание-структуры-vf_list) | Список параметров |

### Описание структуры vf_list
| Параметр | Тип | Описание |
| --- | --- | --- |
| nic_name | string | Название сетевого адаптера |
| vfs_info | []Struct [см. ниже](#описание-структуры-vfs_info) | Список параметров |

### Описание структуры vfs_info
| Параметр | Тип | Описание |
| --- | --- | --- |
| id | int | Идентификатор |
| claimed | bool | Флаг наличия сетевого драйвера |
| vm_id | int | ID виртуальной машины |


## Пример использования
Пример вызова _resource_ функции **decort_cb_vfpool**:

```terraform
resource "decort_cb_vfpool" "vfpool" {
  #наименование vfpool
  #обязательный параметр
  #тип - строка
  name = "test"

  #описание vfpool
  #опциональный параметр
  #тип - строка
  #применяется при создании и редактировании ресурса
  #description = "some"

  #список для предоставления доступа к vfpool перечисленным аккаунтам
  #опциональный параметр
  #тип - массив целых чисел
  #применяется при создании и редактировании ресурса
  #account_access = [1,2]

  #список для предоставления доступа к vfpool перечисленным ресурсным группам
  #опциональный параметр
  #тип - массив целых чисел
  #применяется при создании и редактировании ресурса
  #rg_access = [1,2]

  #блок для указания списка конфигурации
  #опциональный параметр
  #тип - блок
  #config {
  #идентификатор узла
  #обязательный параметр
  #тип - целое число
  #node_id = 1

  #имя верхнеуровневого сетевого интерфейса, VF которого входят в пул
  #обязательный параметр
  #тип - строка
  #nic_name  = "eth0"

  #список идентификаторов VF для NIC узла
  #обязательный параметр
  #тип - массив целых чисел
  #vf_ids = [1,2]
  #}

  #ручное подключение и отключение ресурса
  #опциональный параметр
  #тип - булев
  #enable = true
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.0/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.0/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_vfpool** в переменной `decort_cb_vfpool.vfpool` будут сохранены возвращаемые значения.
