Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_account_disks_list** служит для получения информации об используемых аккаунтом дисках.

## Аргументы

_Data source_ функция **decort_cb_account_disks_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| account_id | int | :heavy_check_mark: | ID аккаунта |
| disk_id | int | :x: | Фильтр по ID диска |
| name | string | :x: | Фильтр по имени диска |
| disk_max_size | int | :x: | Фильтр по макс. размеру диска |
| type | string | :x: | Фильтр по типу диска |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_account_disks_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| disk_id | int | ID диска |
| disk_name | string | Название диска |
| pool_name | string | Название пула, к которому относится диск |
| sep_id | int | ID sep |
| shareable | bool | Флаг, говорящий о том, является ли диск общим |
| size_max | int | Максимальный размер диска |
| type | string | Тип диска |

## Пример использования

Пример вызова _data source_ функции **decort_cb_account_disks_list**:

```terraform
data "decort_cb_account_disks_list" "adl" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 11111

  #фильтр по id диска
  #опциональный параметр
  #тип - целое число
  #disk_id = 100

  #фильтр по имени диска
  #опциональный параметр
  #тип - строка
  #name = "data_disk"

  #фильтр по максимальному размеру диска
  #опциональный параметр
  #тип - целое число
  #disk_max_size = 100

  #тип диска
  #опциональный параметр 
  #тип - строка
  #возможные типы: "b" - boot_disk, "d" - data_disk
  #type = "d"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #тип - строка
  #sort_by = "+name"

  #кол-во страниц для вывода
  #опицональный параметр 
  #тип - целое число
  #page = 1

  #размер страницы
  #опицональный параметр 
  #тип - целое число
  #size = 1
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.1/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_account_disks_list** в переменной `data.decort_cb_account_disks_list.adl` будут сохранены возвращаемые значения.
