Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_audit_linked_jobs** служит для получения списка заданий, связанных с указанным событием системы.

## Аргументы
_Data source_ функция **decort_cb_audit_linked_jobs** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| audit_guid | string | :heavy_check_mark: | GUID события |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_audit_linked_jobs** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| cmd | string | Какая команда была выполнена |
| guid | string | guid |
| nid | int | ID узла |
| state | string | Состояние задания |
| time_create | int | Время создания задания |
| time_start | int | Время начала выполнения задания |
| time_stop | int | Точное окончания исполнения |
| timeout | int | Таймаут |

## Пример использования
Пример вызова _data source_ функции **decort_cb_audit_linked_jobs**:

```terraform
data "decort_cb_audit_linked_jobs" "lj" {
  #guid аудита
  #обязательный параметр
  #тип - строка
  audit_guid = "abcdefg"
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.2/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.2/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_audit_linked_jobs** в переменной `data.decort_cb_audit_linked_jobs.lj.items` будут сохранены возвращаемые значения.
