Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_bservice_snapshot_list** служит для получения информации о всех доступных снимках состояния базовых сервисах. Базовый сервис (basic service) может быть шаблоном, на основе которого создаются вычислительные мощности (computes). По сделанным снимкам состояния возможно восстановления сервиса.

## Аргументы
_Data source_ функция **decort_bservice_snapshot_list** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| service_id | int | :heavy_check_mark: | ID сервиса |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_bservice_snapshot_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | ID снимка состояния |
| label | string | Название снимка состояния |
| timestamp | int | Время создания снимка состояния |
| valid | bool | Флаг, валидность снимка состояния |

## Пример использования
Пример вызова _data source_ функции **decort_bservice_snapshot_list**:
```terraform
data "decort_bservice_snapshot_list" "bsl" {
  #id basic service
  #обязательный параметр
  #тип - целое число
  service_id = 11111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_bservice_snapshot_list** в переменной `data.decort_bservice_snapshot_list.bsl` будут сохранены возвращаемые значения.
