Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_sep_pool** служит для получения информации о pool'e переданного storage endpoint. Storage endpoint (sep) - точка доступа к хранилищу данных. Sep бывает четырех типов:

- des
- hitachi
- dorado
- tatlin

Каждый тип отличается возможной конфигурацией.
Полученные данные могут быть использовать в качестве части конфигурации sep, а так же для ее изменения.

## Аргументы

_Data source_ функция **decort_cb_sep_pool** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| sep_id | int | :heavy_check_mark: | ID storage endpoint |
| pool_name | string | :heavy_check_mark: | Наименование pool, принадлежащего sep |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_sep_pool** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | int | id storage endpoint |
| pool_name | string | Наименование pool |
| pool | []Struct [см. ниже](#описание-структуры-pool) | Информация о pool |

### Описание структуры pool
| Параметр | Тип | Описание |
| --- | --- | --- |
| access_account_ids | []int | Список id аккаунтов, у которых есть доступ к pool |
| access_res_group_ids | []int | Список id ресурсных групп в pool |
| name | string | Название pool |
| pagecache_ratio | int | Процент ответов на запросы, взятых из кеша |
| reference_id | string | ID ссылки |
| types | []string | Типы pool |
| uris | []Struct [см. ниже](#описание-структуры-uris) | Список унифицированных индикаторов ресурса |
| usage_limit | int | Максимально доступное пространство |

### Описание структуры uris
| Параметр | Тип | Описание |
| --- | --- | --- |
| ip | string | ip-адрес |
| port | int | Порт |

## Пример использования

Пример вызова _data source_ функции **decort_cb_sep_pool**:

```terraform
data "decort_cb_sep_pool" "sp" {
  #id sep
  #обязательный параметр
  #тип - целое число
  sep_id = 1111

  #sep pool name
  #обязательный параметр
  #тип - строка
  pool_name = "sep_pool"
}
# and detailed pool will be accessible
# as data.decort_cb_sep_pool.sp.pool
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.4/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_sep_pool** в переменной `data.decort_cb_sep_pool.sp` будут сохранены возвращаемые значения.
