Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_rg_audits** служит для получения информации о аудитах ресурсной группы.

Ресурсная группа в облачной платформе DECORT это способ группирования _compute_-ов (например, по функциональному признаку или принадлежности к одному и тому же проекту). Ресурсную группу можно рассматривать как небольшой персональный дата-центр, в котором размещаются один или несколько серверов и виртуальных сетевых сегментов (ViNS).

Экземпляры _compute_ (виртуальные серверы) всегда создаются в принадлежности к какой-либо ресурсной группе. Как следствие, для создания экземпляра _compute_ помимо других параметров требуется указать идентификатор целевой ресурсной группы. Для получения такого идентификатора можно воспользоваться рассматриваемой здесь _data source_ функцией **decort_cb_rg_audits**.

## Аргументы
_Data source_ функция **decort_cb_rg_audits** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| rg_id | int | :heavy_check_mark: | Идентификатор ресурсной группы |

Пользователь облачной платформы, от лица которого происходит обращение к данной функции, должен иметь доступ к указанному `account` и ресурсной группе. В противном случае возникнет ошибка доступа.

Пользователь облачной платформы задается на стадии инициализации Terraform провайдера DECORT (см. [подробности](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.4/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_rg_audits** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| call | string | Какая команда была выполнена |
| responsetime | float | Время выполнения |
| statuscode | int | Статус выполнения |
| timestamp | float | Точное время исполнения |
| user | string | Кем была выполнена команда |

## Пример использования
Пример вызова _data source_ функции **decort_cb_rg_audits**:

```terraform
data "decort_cb_rg_audits" "rg_audits" {
  #id ресурсной группы
  #обязательный параметр
  #тип - целое число
  rg_id = 1234
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.4/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.4/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_rg_audits** в переменной `data.decort_cb_rg_audits.rg_audits.items` будут сохранены возвращаемые значения.
