Функция доступна в провайдере версии 4.6.0 и выше.

_Resource_ функция **decort_cb_user** служит для управления пользователями. Позволяет создавать, изменять группы доступа и удалять пользователя.

## Аргументы

_Resource_ функция **decort_cb_user** принимает следующие аргументы:



| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| username | string | :heavy_check_mark: | Имя пользователя |
| emailaddress | []string | :heavy_check_mark: | Список адресов электронной почты |
| password | string | :x: | Пароль пользователя |
| groups | []string | :x: | Список групп, в которые включен пользователь |
| apiaccess | []int | :x: | Список групп доступа к API, в которые будет включен данный пользователь |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_user** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| groups | []string | Список групп, в которые включен пользователь |
| ckey | string | CKey |
| meta | []string | Мета информация о пользователе |
| active | bool | Флаг активности пользователя |
| apiaccess | []int | Список групп доступа к API, в которые будет включен данный пользователь |
| authkey | string | Ключ сеанса |
| auth_keys | []string | Список ключей сеанса |
| data | string | Установленные данные |
| description | string | Описание |
| domain | string | Имя домена |
| emailaddress | []string | Список адресов электронной почты |
| gid | int | Grid ID |
| guid | string | Guid пользователя |
| last_check | int | Дата последней проверки |
| mobile | []string | Список мобильных номеров |  |
| protected | bool | Protected |
| roles | []string | Список ролей |
| service_account | bool | Флаг, является ли аккаунт аккаунтом-обслуживания |
| xmpp | []string | Xmpp |

## Пример использования

Пример вызова _resource_ функции **decort_cb_user**:

```terraform
resource "decort_cb_user" "user" {
  #id пользователя
  #обязательный параметр
  #тип - строка
  username = "user1"

  #email адрес пользователя
  #обязательный параметр
  #тип - массив строк
  emailaddress  = ["user1@example.com"]

  #пароль пользователя
  #опциональный параметр
  #тип - строка
  #password  = "user1Password"

  #список групп, к которым принадлежит этот пользователь
  #опциональный параметр
  #тип - массив строк
  #groups  = ["user"]

  #список групп доступа к api, к которым принадлежит этот пользователь
  #опциональный параметр
  #тип - массив целых чисел
  #apiaccess  = [1,2]

}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.7.4/04.02-Инициализация-Terraform-провайдера-DECORT.md).

После успешного завершения такого вызова **decort_cb_user** в переменной `decort_cb_user.user` будут сохранены возвращаемые значения.
