_Data source_ функция **decort_flipgroup_list** служит для получения информации о плавающих группах (флипгруппах)

## Аргументы

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по ID |
| account_id | int | :x: | Фильтр по ID аккаунта |
| conn_id | int | :x: | Фильтр по ID подключения |
| name | string | :x: | Фильтр по названию |
| vins_id | int | :x: | Фильтр по ViNS ID |
| vins_name | string | :x: | Фильтр по имени ViNS |
| extnet_id | int | :x: | Фильтр по ID extnet | 
| by_ip | string | :x: | Фильтр по IP-адресу |
| rg_id | int | :x: | Фильтр по ID рес. группы |
| client_ids | []int | :x: | Фильтр по ID клиентов группы |
| status | string | :x: | Фильтр по статусу плавающей группы |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения (в списке items)

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| client_ids | []int | Список ID подключенных к группе клиентов |
| client_type | string | Тип клиентов, подключаемых к группе |
| conn_id | int | ID подключения |
| net_mask | int | Маска сети |
| conn_type | string | Тип подключения |
| default_gw | string | Шлюз по умолчанию |
| desc | string | Описание группы |
| gid | int | Grid ID платформы |
| guid | int | guid |
| flipgroup_id | int | ID  плавающей группы |
| ip | string | IP плавающей группы |
| meta | []string | Мета информация |
| milestones | int | Веха |
| name | string | Наименование плавающей группы |
| net_id | int | ID сети |
| net_type | string | Тип сети (EXTNET/ViNS) |
| status | string | Статус плавающей группы |

## Пример использования

```terraform
data "decort_flipgroup_list" "fg" {
  #фильтр по id flipgroup 
  #опциональный параметр
  #тип - целое число
  #by_id = 100

  #фильтр по имени flipgroup
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по id vins
  #опциональный параметр
  #тип - целое число
  #vins_id = 100

  #фильтр по имени vins
  #опциональный параметр
  #тип - строка
  #vins_name = "test"

  #фильтр по id extnet
  #опциональный параметр
  #тип - целое число
  #extnet_id = 100

  #фильтр по IP
  #опциональный параметр
  #тип - строка
  #by_ip = "1.1.1.1.1"

  #id ресурсной группы, используется для фильтрации
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #rg_id = 11111

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 2

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 3

  #фильтр по id аккаунта
  #опциональный параметр
  #тип - целое число
  #account_id = 100

  #фильтр по id conn
  #опциональный параметр
  #тип - целое число
  #conn_id = 100

  #фильтр по id клиентов
  #опциональный параметр
  #тип - массив строк
  #client_ids = ["10","11"]

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "CREATED"
}
```

После успешного завершения такого вызова **decort_flipgroup_list** в переменной `data.decort_flipgroup_list.fg` будут сохранены возвращаемые значения.
