Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_extnet** служит для получения информации о внешней сети.

**Для того чтобы использовать данную Resource функцию требуются права администратора!**

## Аргументы
_Data source_ функция **decort_cb_extnet** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| extnet_id | int | :heavy_check_mark: | Идентификатор сети |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_extnet** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| ckey | string | CKey |
| meta | []string | Meta информация |
| default | bool | Является ли внешняя сеть дефолтной |
| default_qos | Struct{} [см.ниже](#описание-блока-default_qos) | Стандартные значения QOS |
| desc | string | Описание внешней сети |
| free_ips | int | Кол-во свободных IP адресов |
| guid | int | ID внешней сети на платформе |
| ipcidr | string | IP CIDR |
| extnet_id | int | ID внешней сети                             | 
| milestones | int | Вехи |
| name | string | Имя внешней сети |
| network_id | int | ID сети |
| ovs_bridge | string | Наименование моста OpenvSwitch внешней сети |
| pre_reservations_num | int | Кол-во резерваций |
| pri_vnfdev_id | int | Pri_VNFDev ID |
| shared_with | []int | ID объектов, использующих сеть |
| status | string | Статус внешней сети |
| vlan_id | int | vLAN ID |
| vnfs | []Struct{} [см.ниже](#описание-блока-vnfs) | Список VNFs |
| check_ips | []string | Список ip адресов для проверки |
| dns | []string | Список DNS адресов |
| excluded | []Struct{} [см.ниже](#описание-блока-excluded) | Список исключенных клиентов |
| gateway | string | IP шлюза |
| network | string | Информация о сети |
| prefix | int | Префикс |
| reservations | []Struct{} [см.ниже](#описание-блока-reservations) | Резервации |

### Описание блока default_qos

| Параметр | Тип | Описание |
| --- | --- | --- |
| e_rate | int | Egress Rate |
| guid | string | Grid Unique ID |
| in_rate | int | Ingress Rate |
| in_burst | int | Ingress Burst |

### Описание блока vnfs

| Параметр | Тип | Описание |
| --- | --- | --- |
| dhcp | int | ID DHCP |

### Описание блока excluded

| Параметр | Тип | Описание |
| --- | --- | --- |
| client_type | string | Тип клиента |
| desc | string | Описание |
| domain_name | string | Имя домена |
| hostname | string | Имя хоста |
| ip | string | IP адрес клиента |
| mac | string | MAC адрес клиента |
| type | string | Тип исключения |
| vm_id | int | VM ID |

### Описание блока reservations

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| client_type | string | Тип клиента |
| domain_name | string | Имя домена |
| desc | string | Описание |
| hostname | string | Имя хоста |
| ip | string | IP адрес клиента |
| mac | string | MAC адрес клиента |
| type | string | Тип исключения |
| vm_id | int | VM ID |

## Пример использования

```terraform
data "decort_cb_extnet" "ex" {
  #id сети
  #обязательный параметр 
  #тип - целое число
  extnet_id = 13
}
```

После успешного завершения такого вызова **decort_cb_extnet** в переменной `data.decort_cb_extnet.e` будут сохранены возвращаемые значения.
