Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_extnet_list** служит для получения информации о внешней сети.

**Для того чтобы использовать данную Resource функцию требуются права администратора!**

## Аргументы
_Data source_ функция **decort_cb_extnet_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| account_id | int | :x: | ID аккаунта для фильтрации результата поиска |
| by_id | int | :x: | Фильтр по extnet ID |
| name | string | :x: | Фильтр по имени extnet |
| network | string | :x: | Фильтр по сети |
| vlan_id | int | :x: | Фильтр по VLAN ID |
| vnfdev_id | int | :x: | Фильтр по VnfDEV ID |
| status | string | :x: | Фильтр по статусу |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страниц |
| size | int | :x: | Размер страницы |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_extnet_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| ckey | string | CKey |
| meta | []string | Meta информация |
| default | bool | Является ли внешняя сеть дефолтной |
| default_qos | Struct{} [см.ниже](#описание-блока-default_qos) | Стандартные значения QOS |
| desc | string | Описание внешней сети |
| free_ips | int | Кол-во свободных IP адресов |
| gid | int | Grid ID платформы |
| guid | int | ID внешней сети на платформе |
| ipcidr | string | IP CIDR |
| extnet_id | int | ID внешней сети                            | 
| milestones | int | Вехи |
| name | string | Имя внешней сети |
| network_id | int | ID сети |
| ovs_bridge | string | Наименование моста OpenvSwitch внешней сети |
| pre_reservations_num | int | Кол-во резерваций |
| pri_vnfdev_id | int | Pri_VNFDev ID |
| shared_with | []int | ID объектов, использующих сеть |
| status | string | Статус внешней сети |
| vlan_id | int | vLAN ID |
| vnfs | []Struct{} [см.ниже](#описание-блока-vnfs) | Список VNFs |
| check_ips | []string | Список ip адресов для проверки |

### Описание блока default_qos

| Параметр | Тип | Описание |
| --- | --- | --- |
| e_rate | int | Egress Rate |
| guid | string | Grid Unique ID |
| in_rate | int | Ingress Rate |
| in_burst | int | Ingress Burst |

### Описание блока vnfs

| Параметр | Тип | Описание |
| --- | --- | --- |
| dhcp | int | ID DHCP |


## Пример использования
Пример вызова _data source_ функции **decort_cb_extnet_list**:
```terraform
data "decort_cb_extnet_list" "el" {
  #id аккаунта для фильтрации результата
  #опциональный параметр
  #тип - целое число
  #account_id = 1111111

  #фильтр по id внешней сети
  #опциональный параметр
  #тип - целое число
  #by_id = 100

  #фильтр по имени внешней сети
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по IP внешней сети
  #опциональный параметр
  #тип - строка
  #network = "test"

  #фильтр по id vlan
  #опциональный параметр
  #тип - целое число
  #vlan_id = 100

  #фильтр по id vnfDevices
  #опциональный параметр
  #тип - целое число
  #vnfdev_id = 100

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #кол-во страниц для вывода
  #опциональный параметр 
  #тип - целое число
  #page = 1

  #размер страницы
  #опциональный параметр 
  #тип - целое число
  #size = 1
}
```

После успешного завершения такого вызова **decort_cb_extnet_list** в переменной `data.decort_cb_extnet_list.el.items` будут сохранены возвращаемые значения.
