Функция доступна в провайдере версии 4.4.1 и выше.

_Data source_ функция **decort_k8s_wg_cloud_init** служит для получения информации об предустановленных настройках группы воркеров кластера Kubernetes (k8s)

## Аргументы

_Data source_ функция **decort_k8s_wg_cloud_init** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| k8s_id | int | :heavy_check_mark: | ID кластера |
| wg_id | int | :heavy_check_mark: | ID группы воркеров |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_k8s_wg_cloud_init** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| cloud_init | string | Предустановленные настройки группы воркеров кластера Kubernetes (k8s) |

## Пример использования

Пример вызова _data source_ функции **decort_k8s_wg_cloud_init**:

```terraform
data "decort_k8s_wg_cloud_init" "wg_cloud_init" {
  #id кластера
  #обязательный параметр
  #тип - целое число
  k8s_id = 977

  #id группы воркеров
  #обязательный параметр
  #тип - целое число
  wg_id = 2110
}
```

После успешного завершения такого вызова **decort_k8s_wg_cloud_init** в переменной `data.decort_k8s_wg_cloud_init.wg_cloud_init` будут сохранены возвращаемые значения.

