Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_grid** служит для получения информации о grid. Grid это пространства, на которых возможно размещение виртуальных машин. 

## Аргументы
_Data source_ функция **decort_cb_grid** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| grid_id | int | :heavy_check_mark: | ID grid |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_grid** возвращает в указанную при вызове переменную, которая состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| grid_id | int | ID grid |
| ckey | string | ckey |
| meta | []string | Мета информация |
| auth_broker | []string | auth broker |
| flag | string | Флаг |
| gid | int | ID grid |
| guid | int | Внутренний id |
| id | int | ID |
| location_code | string | Код расположения grid |
| name | string | Наименование grid |


## Пример использования
Пример вызова _data source_ функции **decort_cb_grid**:
```terraform
data "decort_cb_grid" "my_grid" {
  #id grid для получения информации
  #обязательный параметр 
  #тип - целое число
  grid_id = 215
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.2/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_grid** в переменной `data.decort_cb_grid.my_grid` будут сохранены возвращаемые значения.
