Функция доступна в провайдере версии 4.4.1 и выше.

_Data source_ функция **decort_account_resource_consumption_list** служит для получения информации о количестве потребляемых и зарезервированных ресурсов (процессор, оперативная память, диск) доступных аккаунту

## Аргументы

_Data source_ функция **decort_account_resource_consumption_list** не принимает аргументы.

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_account_resource_consumption_list** возвращает в указанную при вызове переменную, в поле _items_, массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | id аккаунта |
| consumed | Struct{} [см. ниже](#описание-структуры-consumed-и-reserved) | Информация о текуших ресурсах |
| reserved | Struct{} [см. ниже](#описание-структуры-consumed-и-reserved) | Информация о зарезервированных аккаунтом ресурсах |

### Описание структуры consumed и reserved
| Параметр | Тип | Описание |
| --- | --- | --- |
| cpu | int | Количество CPU |
| disk_size | float | Размер диска |
| disk_size_max | float | Максимальный размер диск |
| extips | int | Внешние IPs |
| exttraffic | int | Внешний Traffic |
| gpu | int | Количество GPU |
| ram | int | Количество RAM |
| seps | []Struct{} [см . ниже](#описание-структуры-seps) | Информация о seps |

### Описание структуры seps
| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | int | ID SEP. SEP это способ идентифицировать конкретную систему хранения, на ресурсах которой размещён данный диск |
| data_name | string | Имя пула информации внутри SEP'а |
| disk_size | float | Количество занятого места |
| disk_size_max | float | Размер диска |

## Пример использования

Пример вызова _data source_ функции **decort_account_resource_consumption_list**:

```terraform
data "decort_account_resource_consumption_list" "rc_list" {
  #Нет входных параметров
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.3/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_account_resource_consumption_list** в переменной `data.decort_account_resource_consumption_list.rc_list` будут сохранены возвращаемые значения.
