Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_audit** служит для получения информации об указанном событий системы, вызванном действиями пользователя.

## Аргументы
_Data source_ функция **decort_cb_audit** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| audit_guid | string | :heavy_check_mark: | GUID события |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_audit** возвращает в указанную при вызове переменную следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| audit_guid | string | GUID события |
| args | string | Аргументы вызова |
| kwargs | string | Аргументы вызова |
| call | string | Какая команда была выполнена |
| guid | string | ID ресурса |
| remote_addr | string | Адрес, на который отправляются журналы |
| result | string | json строка ответа |
| responsetime | float | Время выполнения |
| status_code | int | Статус выполнения |
| tags | string | Тэги |
| timestamp | float | Точное время исполнения |
| timestamp_end | float | Время окончания исполнения |
| user | string | Кем была выполнена команда |

## Пример использования
Пример вызова _data source_ функции **decort_cb_audit**:

```terraform
data "decort_cb_audit" "audit" {
  #guid аудита
  #обязательный параметр
  #тип - строка
  audit_guid = "abcdefg"

}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.3/04.02-Инициализация-Terraform-провайдера-DECORT.md) и [пример](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.8.3/02.-Пример-работы.md)). 

После успешного завершения такого вызова **decort_cb_audit** в переменной `data.decort_cb_audit.audit` будут сохранены возвращаемые значения.
