Функция доступна в провайдере версии 2.3 и выше.

_Data source_ функция **decort_extnet** служит для получения информации о внешней сети.

## Аргументы
_Data source_ функция **decort_extnet** принимает следующие аргументы:
| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| net_id | int | :heavy_check_mark: | Идентификатор сети |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_extnet** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| net_id | int | ID сети |
| meta | []string | Мета информация |
| check_ips | []string | Список ip адресов для проверки |
| default | bool | Является ли сеть сетью по умолчанию |
| default_qos | [см. ниже](#описание-структуры-default-qos) | Quality of Service по умолчанию |
| desc | string | Описание |
| dns | []string | Список dns |
| excluded | []string | Список исключенных ip-адресов |
| free_ips | int | Кол-во свободных ip-адресов |
| gateway | string | Сетевые врата |
| gid | int | Grid id |
| guid | int | Внутренний id сети |
| ipcidr | string | Маска сети |
| milestones | int | Время жизни |
| net_name | string | Имя сети |
| network | string | Информация о сети |
| network_id | int | Идентификатор сети |
| ntp | []string | Список cерверов NTP |
| pre_reservations_num | int | Количество зарезервированных ресурсов |
| prefix | int | Префикс |
| pri_vnf_dev_id | int | ID внутренней сети для разработки |
| reservations | []Struct [см. ниже](#описание-структуры-reservations) | Зарезервированные части сети |
| shared_with | []int | Список ресурсов, имеющих доступ к сети |
| status | string | Статус сети |
| vlan_id | int | Идентификатор vlan |
| vnfs | []Struct [см. ниже](#описание-структуры-vnfs) | Информация о vnfs |

### Описание структуры default qos
| Параметр | Тип | Описание |
| --- | --- | --- |
| e_rate | int | Минимальное кол-во потерь |
| guid | string | id сервиса |
| in_burst | int | Потери в режиме burst |
| in_rate | int | Потери в режиме rate |

### Описание структуры reservations
| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | ID аккаунта |
| client_type | string | Тип клиента |
| domainname | string | Имя домена |
| hostname | string | Имя хоста |
| desc | string | Описание |
| ip | string | IP-адрес |
| mac | string | MAC-адрес |
| type | string | Тип |
| vm_id | int | ID виртуальной машины |

### Описание структуры vnfs
| Параметр | Тип | Описание |
| --- | --- | --- |
| dhcp | int | Информация о dhcp |

## Пример использования
Пример вызова _data source_ функции **decort_extnet**:
```terraform
data "decort_extnet" "e" {
  #идентификатор сети
  #обязательный параметр
  #тип - целое число
  net_id = 1111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_extnet** в переменной `data.decort_extnet.e` будут сохранены возвращаемые значения.
