_Data source_ функция **decort_k8ci_list** служит для получения информации о доступных k8ci

## Аргументы

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| by_id | int | :x: | Фильтр по ID k8ci |
| name | string | :x: | Фильтр по имени |
| status | string | :x: | Фильтр по статусу |
| worker_driver | string | :x: | Фильтр по драйверу worker |
| master_driver | string | :x: | Фильтр по драйверу master |
| network_plugin | string | :x: | Фильтр по плагину сети (flannel, calico или weavenet) |
| include_disabled | bool | :x: | Дополнить рез-тат выключенными k8ci |
| sort_by | string | :x: | Фильтр по одному из поддерживаемых полей, формат: +или- название поля |
| page | int | :x: | Номер страницы |
| size | int | :x: | Размер страницы |

## Возвращаемые значения (в списке items)

| Параметр | Тип | Описание |
| --- | --- | --- |
| k8ci_id | int | ID k8ci |
| name | string | Наименование k8ci |
| lb_image_id | int | ID образа балансировщика |
| network_plugins | []string | Список доступных плагинов сети |
| status | string | Статус |
| desc | string | Описание |
| created_time | int | Время создания |
| version | string | Версия |

## Пример использования

```terraform
data "decort_k8ci_list" "k8ci_list" {
  #фильтр по id кластера
  #опциональный параметр
  #тип - целое число
  #by_id = 100

  #фильтр по имени кластера
  #опциональный параметр
  #тип - строка
  #name = "test"

  #фильтр по ip
  #опциональный параметр
  #тип - строка
  #ip_address = "test"

  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - целое число
  #rg_id = 100

  #фильтр по id балансировщика нагрузки
  #опциональный параметр
  #тип - целое число
  #lb_id = 100

  #фильтр по id ресурсной группы
  #опциональный параметр
  #тип - целое число
  #bservice_id = 100

  #фильтр по статусу
  #опциональный параметр
  #тип - строка
  #status = "ENABLED"

  #фильтр по техническому статусу
  #опциональный параметр
  #тип - строка
  #tech_status = "STOPPED"

  #включение удаленных k8s в результат
  #опциональный параметр
  #тип - булев
  #если не задан - выводятся все неудаленные данные
  #includedeleted = true

  #сортировка по одному из поддерживаемых полей
  #опциональный параметр
  #тип - строка
  #формат - "+поле" по возрастанию / "-поле" по убыванию
  #sort_by = "+name"

  #номер страницы для отображения
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #page = 1

  #размер страницы
  #опциональный параметр
  #тип - целое число
  #если не задан - выводятся все доступные данные
  #size = 1
}
```

После успешного завершения такого вызова **decort_k8ci_list** в переменной `data.decort_k8ci_list.k8ci_list` будут сохранены возвращаемые значения.
