Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_account_resource_consumption_get** служит для получения информации о количестве потребляемых и зарезервированных ресурсов (процессор, оперативная память, диск) по конкретному аккаунту

## Аргументы

_Data source_ функция **decort_cb_account_resource_consumption_get** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| account_id | int | :heavy_check_mark: | ID аккаунта |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_account_resource_consumption_get** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | id аккаунта |
| consumed | Struct{} [см. ниже](#описание-структуры-consumed-и-reserved) | Информация о текуших ресурсах |
| reserved | Struct{} [см. ниже](#описание-структуры-consumed-и-reserved) | Информация о зарезервированных аккаунтом ресурсах |
| resource_limits | Struct{} [см. ниже](#описание-структуры-resource-limits) | Лимиты ресурсов |

### Описание структуры consumed и reserved
| Параметр | Тип | Описание |
| --- | --- | --- |
| cpu | int | Количество CPU |
| disksize | float | Размер диска |
| disksizemax | float | Максимальный размер диск |
| extips | int | Внешние IPs |
| exttraffic | int | Внешний Traffic |
| gpu | int | Количество GPU |
| ram | int | Количество RAM |
| seps | []Struct{} [см . ниже](#описание-структуры-seps) | Информация о seps |

### Описание структуры seps
| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | string | ID SEP. SEP это способ идентифицировать конкретную систему хранения, на ресурсах которой размещён данный диск |
| data_name | string | Имя пула информации внутри SEP'а |
| disk_size | float | Количество занятого места |
| disk_size_max | float | Размер диска |

### Описание структуры resource limits
| Параметр | Тип | Описание |
| --- | --- | --- |
| cu_c | float | Количество ядер CPU |
| cu_d | float | Размер диска |
| cu_dm | float | Использованный размер хранилища виртуального диска | 
| cu_i | float | Количество публичных IP адресов |
| cu_m | float | размер RAM |
| cu_np | float | Хранилище траффика |
| gpu_units | float | количество GPU ядер |

## Пример использования

Пример вызова _data source_ функции **decort_cb_account_resource_consumption_get**:

```terraform
data "decort_cb_account_resource_consumption_get" "rc_get" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_account_resource_consumption_get** в переменной `data.decort_cb_account_resource_consumption_get.rc_get` будут сохранены возвращаемые значения.
