Функция доступна в провайдере версии 4.6.0 и выше.

_Data source_ функция **decort_cb_account_available_templates_list** служит для получения информации о списках доступных образов аккаунту

## Аргументы

_Data source_ функция **decort_cb_account_available_templates_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| account_id | int | :heavy_check_mark: | ID аккаунта |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_account_available_templates_list** возвращает в указанную при вызове переменную следующие значения:

| Параметр | Тип | Описание |
| --- | --- | --- |
| items | []int | Список доступных образов аккаунту |  

## Пример использования

Пример вызова _data source_ функции **decort_cb_account_available_templates_list**:

```terraform
data "decort_cb_account_available_templates_list" "atl" {
  #id аккаунта
  #обязательный параметр
  #тип - целое число
  account_id = 11111
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_account_available_templates_list** в переменной `data.decort_cb_account_available_templates_list.atl` будут сохранены возвращаемые значения.
