Функция доступна в провайдере версии 4.9.0 и выше.

_Data source_ функция **decort_cb_sep_template** служит для получения шаблона storage endpoint. Storage endpoint (sep) - точка доступа к хранилищу данных. Sep бывает следующих типов:

- des
- hitachi
- dorado
- tatlin
- shared
- local

Каждый тип отличается возможным шаблоном.
Шаблон представляет собой json - объект, который можно сохранить в файл с расширением .json для дальнейшего использования.

## Аргументы

_Data source_ функция **decort_cb_sep_template** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| sep_type | string | :heavy_check_mark: | Sep Type |
| lang | string | :heavy_check_mark: | Language |

## Возвращаемые значения

В случае успешного выполнения _data source_ функция **decort_cb_sep_template** возвращает в указанную при вызове переменную элемент, который состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| sep_id | int | id storage endpoint |
| config | json string | Конфигурация sep |

## Пример использования

Пример вызова _data source_ функции **decort_cb_sep_template**:

```terraform
data "decort_cb_sep_template" "compute_template" {

   #тип сеп
   #возможные значения - hitachi, dorado, tatlin, shared, local, des
   #обязательный параметр
   #тип - строка
   sep_type = "dorado"

   #язык
   #возможные значения - ru, en
   #обязательный параметр
   #тип - строка  
   lang = "en"

}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)).

После успешного завершения такого вызова **decort_cb_sep_template** в переменной `data.decort_cb_sep_template.compute_template` будут сохранены возвращаемые значения.

Чтобы получить доступ к конфигурации и сохранить ее в файл .json, необходимо:

1. определить в .tf - файле дополнительный output с любым именем, в который запишется информация о конфигурации sep и обернуть ее в вызов функции jsondecode для декодирования информации.

```terraform
output "template" {
    value = jsondecode(data.decort_cb_sep_template.compute_template.sep_template)
}
```

2. Применить изменения в терраформе.

```bash
terraform apply
```

3. Сохранить данные из output в .json - файл.

```bash
terraform output -json sep_template >> config.json
```

В общем случае это будет выглядеть как указано ниже.

```bash
terraform output -json <output-name> >> <file-name>.json
```
