Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_lb** служит для получения информации о балансировщике нагрузки (load balancer). Балансировщик нагрузки служит для равномерного распределения сетевой нагрузки на сервисы кубернетеса.

## Аргументы
_Data source_ функция **decort_cb_lb** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- | 
| lb_id | int | :heavy_check_mark: | ID балансировщика |


## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_lb** возвращает следующие параметры:

| Параметр | Тип | Описание |
| --- | --- | --- |
| ha_mode | bool | Флаг, показывающий, включен ли режим haproxy |
| ckey | string | CKey |
| meta | []string | Мета информация |
| acl | string | Cписок Acces Control |
| backend_haip | string | Backend highly available ip |
| backends | []Struct{} [см. ниже](#описание-структуры-backends) | Список бекендов |
| desc | string | Описание |
| dp_api_password | string | Пароль пользователя для работы |
| dp_api_user | string | Имя пользователя для работы |
| extnet_id | int | ID внешней сети |
| frontend_haip | string | Frontend highly available ip |
| frontends | []Struct{} [см. ниже](#описание-структуры-frontends) | Список фронтендов   
| gid | int | Grid ID балансировщика |
| guid | int | ID балансировщика |
| lb_id | int | ID балансировщика |
| image_id | int | ID образа |
| manager_id | int | ID ресурса, к которому принадлежит данный балансировщик |
| manager_type | string | Тип ресурса, к которому принадлежит данный балансировщик |
| milestones | int | Вехи |
| name | string | Имя балансировщика |
| part_k8s | bool | Является ли балансироващик частью кластера |
| primary_node | Struct{} [см. ниже](#описание-структуры-primary_node) | Главный узел |
| rg_id | int | ID ресурсной группы |
| secondary_node | Struct{} [см. ниже](#описание-структуры-secondary_node) | Второй узел |
| status | string | Статус |
| tech_status | string | Технический статус |
| user_managed | bool | Флаг указывающий, может ли пользователь управлять балансировщиком напрямую |
| vins_id | int | ID виртуальной сети |

### Описание структуры backends
| Параметр | Тип | Описание |
| --- | --- | --- |
| algorithm | string | Алгоритм работы бекенда |
| guid | string | ID ресурса |
| name | string | Имя бекенда |
| server_default_settings | Struct{} [см. ниже](#описание-структуры-server_default_settings) | Описание настроек серверов бекенда по умолчанию |
| servers | []Struct{} [см. ниже](#описание-структуры-servers) | Список серверов |

### Описание структуры server_default_settings
| Параметр | Тип | Описание |
| --- | --- | --- |
| downinter | int | Интервал между проверками на недоступность сервера |
| guid | string | ID ресурса |
| inter | int | Интервал между проверками на доступность сервера |
| rise | int | Кол-во попыток, после которых, сервер будет вновь включен в схему балансирования |
| fall | int | Кол-во неудачных попыток, после которых, сервер получит статус "unavailable" |
| slowstart | int | Интервал, в мс, в через который сервер получит статус "available" |
| maxconn | int | Кол-во соединений к северу, при достижении этого кол-ва, сервера выходит из схемы балансирования |
| maxqueue | int | Кол-во соедений в очереди к серверу |
| weight | int | Вес сервера для работы алгоритма балансирования по весу |

### Описание структуры servers
| Параметр | Тип | Описание |
| --- | --- | --- |
| address | string | Адрес сервера |
| check | string | Включены ли проверки |
| guid | string | ID ресурса |
| name | string | Имя сервера |
| port | int | Порт сервера |
| server_settings | [см. ниже](#описание-структуры-server_settings) | Настройки сервера |

### Описание структуры server_settings
| Параметр | Тип | Описание |
| --- | --- | --- |
| downinter | int | Интервал между проверками на недоступность сервера |
| guid | string | ID ресурса |
| inter | int | Интервал между проверками на доступность сервера |
| rise | int | Кол-во попыток, после которых, сервер будет вновь включен в схему балансирования |
| fall | int | Кол-во неудачных попыток, после которых, сервер получит статус "unavailable" |
| slowstart | int | Интервал, в мс, в через который сервер получит статус "available" |
| maxconn | int | Кол-во соединений к северу, при достижении этого кол-ва, сервера выходит из схемы балансирования |
| maxqueue | int | Кол-во соедений в очереди к серверу |
| weight | int | Вес сервера для работы алгоритма балансирования по весу |

### Описание структуры frontends
| Параметр | Тип | Описание |
| --- | --- | --- |
| backend | string | Имя бекенда, к которому подключен фронтенд |
| guid | string | ID ресурса |
| name | string | Имя фронтенда |
| bindings | []Struct{} [см. ниже](#описание-структуры-bindings) | Привязки фронтенда |

### Описание структуры bindings
| Параметр | Тип | Описание |
| --- | --- | --- |
| address | string | Адрес, к которому привязан фронтенд |
| name | string | Имя привязки |
| port | int | Порт привязки |
| guid | string | ID ресурса |

### Описание структуры primary_node
| Параметр | Тип | Описание |
| --- | --- | --- |
| backend_ip | string | IP адрес бекенда |
| compute_id | int | ID виртуальной машины |
| frontend_ip | string | IP адрес фронтенда |
| guid | string | ID ресурса |
| mgmt_ip | string | IP адрес |
| network_id | int | ID сети |

### Описание структуры secondary_node
| Параметр | Тип | Описание |
| --- | --- | --- |
| backend_ip | string | IP адрес бекенда |
| compute_id | int | ID виртуальной машины |
| frontend_ip | string | IP адрес фронтенда |
| guid | string | ID ресурса |
| mgmt_ip | string | IP адрес |
| network_id | int | ID сети |

## Пример использования
Пример вызова _data source_ функции **decort_cb_lb**:
```terraform
data "decort_cb_lb" "lb" {
  #id балансировщика нагрузки
  #обязательный параметр
  #тип - целое число
  lb_id = 238
}
```

После успешного завершения такого вызова **decort_cb_lb** в переменной `data.decort_cb_lb.lb` будут сохранены возвращаемые значения.
