Функция доступна в провайдере версии 4.5.1 и выше.

_Data source_ функция **decort_cb_vins_nat_rule_list** служит для получения списка правил NAT (переадресации портов) на внутренней сети.

## Аргументы
_Data source_ функция **decort_cb_vins_nat_rule_list** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| vins_id | int | :heavy_check_mark: | ID vins |

## Возвращаемые значения
В случае успешного выполнения _data source_ функция **decort_cb_vins_nat_rule_list** возвращает в указанную при вызове переменную, в поле _items_ массив, каждый элемент которого состоит из следующих параметров:

| Параметр | Тип | Описание |
| --- | --- | --- |
| id | int | ID правила |
| local_ip | string | Локальный IP адрес |
| local_port | int | Локальный порт |
| protocol | string | Протокол |
| public_port_end | int | Конец диапазона портов |
| public_port_start | int | Начало диапазона портов |
| vm_id | int | ID виртуальной машины |
| vm_name | string | Имя виртуальной машины |

## Пример использования
Пример вызова _data source_ функции **decort_cb_vins_nat_rule_list**:
```terraform
data "decort_cb_vins_nat_rule_list" "nrl" {
  #id желаемого vins
  #обязательный параметр
  #тип - целое число
  vins_id = 10101
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова **decort_cb_vins_nat_rule_list** в переменной `data.decort_cb_vins_nat_rule_list.nrl` будут сохранены возвращаемые значения.
