Функция доступна в провайдере версии 4.0.0 и выше.

_Resource_ функция **decort_cb_disk_replication** служит для управления репликами дисков ("disk") в облачной платформе DECORT.

## Аргументы
_Resource_ функция **decort_cb_disk_replication** принимает следующие аргументы:

| Аргумент | Тип | Обязательный | Описание |
| --- | --- | --- | --- |
| disk_name | string | :heavy_check_mark: | Наименование реплики диска |
| disk_id | int | :heavy_check_mark: | id диска из которого будет создана реплика |
| sep_id | int | :heavy_check_mark: | id сепа реплики диска |
| pool_name | string | :heavy_check_mark: | Наименование пула реплики диска |
| pause | bool | :x: | Приостановить / Возобновить связь между диском и репликой |
| reverse | bool | :x: | Поменять роли между диском и репликой |
| start | bool | :x: | Установить / Прекратить связь между диском и репликой |
| detach | bool | :x: | Отсоединить реплику от ВМ при удалении |
| permanently | bool | :x: | Удалить реплику безвозвратно |

## Возвращаемые значения
В случае успешного выполнения _Resource_ функция **decort_cb_disk_replication** возвращает в указанную при вызове переменную следующие значения:

| Параметр | Тип | Описание |
| --- | --- | --- |
| account_id | int | Уникальный идентификатор аккаунта-владельца реплики диска |
| account_name | string | Имя аккаунта ("account"), которому принадлежит данная реплика диска |
| acl | []string | Список доступов к реплике диска |
| boot_partition | int | Кол-во разделов реплики диска |
| computes | Struct{} [см. ниже](#описание-структуры-computes) | Информация о компьютах (виртуальных машинах) |
| created_time | int | Время создания |
| deleted_time | int | Время удаления |
| desc | string | Текстовое описание диска реплики |
| destruction_time | int | Время окончательного удаления |
| devicename | string | Наименование устройства |
| disk_path | string | Адрес реплики диска |
| gid | int | Идентификатор площадки (grid id) |
| guid | int | Идентификатор реплики диска |
| id | int | Идентификатор реплики диска |
| image_id | int | Идентификатор образа, содержимое которого было склонировано/скопировано в данную реплику диска |
| images | []int | Идентификаторы образов, использующих реплику диска |
| iotune | Struct{}[см. ниже](#описание-cтруктуры-iotune) | Информация об ограничениях IO реплики диска |
| iqn | string | iqn реплики диска |
| login | string | Логин для доступа к реплике диска |
| milestones | int | Вехи |
| disk_name | string | Наименование реплики диска |
| order | int | Номер диска |
| params | string | Параметры диска |
| parent_id | int | id родительского диска |
| passwd | string | Пароль для доступа к диску |
| pci_slot | int | id pci слота, к которому подключена реплика |
| pool | string | Имя пула в системе хранения, на ресурсах которой размещёна реплика |
| present_to | map[string]int | Список ID ресурсов, которым предоставлена реплика диска |
| purge_time | int | Время последней попытки |
| replica_disk_id | int | Идентификатор реплики диска. Дублирует значение параметра `id`. |
| replication | Struct{} [см. ниже](#описание-структуры-replication) | Информация о реплике диска |
| reality_device_number | int | Реальный номер устройства |
| res_id | int | id ресурса |
| res_name | string | Наименование ресурса |
| role | string | Роль диска |
| sep_id | int | Идентификатор Storage Endpoint Provider (SEP). SEP это способ идентифицировать конкретную систему хранения, на ресурсах которой размещёна реплика |
| sep_type | string | Тип SEP. Определяет тип системы хранения и содержит одно из заданных в облачной платформе значений |
| shareable | bool | Флаг, отвечающий за доступность реплики дургим ресурсам |
| size_max | int | Размер диска в ГБ |
| size_used | int | Кол-во используемого места, в ГБ |
| snapshots | []Struct{}[см. ниже](#описание-структуры-snapshots) | Снимки состояния реплики |
| status | string | Статус реплики |
| status_replication | string | Статус связи между диском и репликой |
| tech_status | string | Технический статус реплики |
| type | string | Тип реплики с точки зрения ее роли в составе _compute_. Может принимать одно из фиксированных значений:<br/>"B" - признак загрузочного диска ("boot").<br/>"D" - признак дополнительного диска ("data") |
| vmid | int | Идентификатор виртуальной машины (устаревшее) |

### Описание структуры computes 
| Параметр | Тип | Описание |
| --- | --- | --- |
| compute_id | int | Идентификатор компьюта |
| compute_name | string | Имя компьюта |

### Описание cтруктуры iotune 
| Параметр | Тип | Описание |
| --- | --- | --- |
| read_bytes_sec | int | Кол-во байт для чтения в секунду |
| read_bytes_sec_max | int | Максимальное кол-во байт для чтения |
| read_iops_sec | int | Кол-во операций чтения io в секунду |
| read_iops_sec_max | int | Максимальное число io операций чтения |
| size_iops_sec | int | Размер io операций |
| total_bytes_sec | int | Общий размер байт в секунду |
| total_bytes_sec_max | int | Максимальный общий размер байт в секунду |
| total_iops_sec | int | Общее кол-во io операций в секунду |
| total_iops_sec_max | int | Максимальное общее кол-во io операций в секунду |
| write_bytes_sec | int | Кол-во байт для записи в секунду |
| write_bytes_sec_max | int | Максимальное кол-во байт для записи в секунду |
| write_iops_sec | int | Кол-во операций записи в секунду |
| write_iops_sec_max | int | Максимальное число операций записей |

### Описание структуры replication 
| Параметр | Тип | Описание |
| --- | --- | --- |
| disk_id | int | id диска |
| pool_id | string | id пула |
| role | string | Роль диска (главный или реплика) |
| self_volume_id | string | id раздела |
| storage_id | int | id хранилища |
| volume_id | int | id раздела |

### Описание структуры snapshots 
| Параметр | Тип | Описание |
| --- | --- | --- |
| guid | string | id снимка |
| label | string | Наименование снимка |
| res_id | string | Ссылка на снимок |
| snap_set_guid | string | Установленный id снимка |
| snap_set_time | int | Установленное время снимка |
| timestamp | int | Время снимка |

## Пример использования

Пример вызова _resource_ функции **decort_cb_disk_replication**:

```terraform
resource "decort_cb_disk_replication" "dr" {
  #id диска из которого будет создана реплика
  #обязательный параметр
  #тип - целое число
  disk_id = 20100

  #имя реплики диска
  #обязательный параметр
  #тип - строка
  disk_name = "test"

  #sep id
  #обязательный параметр
  #тип - целое число
  sep_id = 1

  #название pool
  #обязательный параметр
  #тип - строка
  pool_name = "some"

  #флаг паузы
  #опциональный параметр
  #тип - булев
  #pause = false

  #флаг для изменения ролей дисков
  #опциональный параметр
  #тип - булев
  #reverse = false

  #флаг для запуска связи между диском и репликой
  #опциональный параметр
  #тип - булев
  #start = false

  #флаг для отключения диска от ВМ при удалении
  #опциональный параметр
  #тип - булев
  #detach = false

  #флаг для удаления реплики диска безвозвратно
  #опциональный параметр
  #тип - булев
  #permanently = false
}
```

Данный пример подразумевает, что ранее по тексту tf-файла выполнена корректная инициализация провайдера (подробнее об инициализации Terraform провайдера DECORT см. соответствующий [раздел](https://repository.basistech.ru/BASIS/terraform-provider-decort/src/branch/main/wiki/4.9.0/04.02-Инициализация-Terraform-провайдера-DECORT.md)). 

После успешного завершения такого вызова _resource_ функции **decort_cb_disk_replication** в переменной `decort_cb_disk_replication.dr` будут сохранены возвращаемые значения. 
